/*
 *  TEX Device Driver  ver 2.02-
 *  copyright(c) 1988,89 by TSG, 1990-94 SHIMA
 *
 *  PREVIEWER ver 2.02-
 *  device.c : previewer module
 *             4th edition
 *
 *  	--- Hints to rewite to other Graphic Interfaces ---
 *
 *  1. Rewrite Device dependent functions indicated
 *	   The function to transfer data from MEMORY to Graphic VRAM
 *	   Also the function to print strings if we want to display page numbers
 *
 *  2. USE_98RAM = 0  or/and  BLOCK_MOVE = 0  or/and  $define NEMS 1
 *	   if necessary (NEMS = 1 -> does not use EMS memory)
 */

#define	USE_ASM			1	/* Use an assembly language in Gbitblt() */
#define	BLOCK_MOVE		1	/* Use Block Move in Graphic Accelerator */
#define	USE_98RAM		1	/* Use Graphic VRAM of PC-9801			 */
#define	GSAVE			1	/* Use function to save in BMP files	 */
#define	GRAY_SCALE		1	/* Use Gray Scale for 1/2 view image	 */
#define	GRAY_TABLE		1	/* Make Gray Scale by Tabel				 */

#define	TITLE_COMMENT	""

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#define _DEF_STDIO_H_
#include <dos.h>
#include <mem.h>
#include <alloc.h>
#include <conio.h>
#define _DEF_DOS_H_

#include "dd.h"
#include "err.h"

/* 					---- Data for GA-1024A/1280A ---					*/

#include "gagraph.h"
int   	disp_reso;			/* ʃ|h       resolution  colors
										    -1: deafult       16
											 0: default        2
											 4:  640 x  480   16
											 8:  640 x  480    2
											10:  800 x  600   16
											12:  800 x  600    2
											 3: 1024 x  768   16
											 7: 1024 x  768    2
											17: 1280 x  960   16
											19: 1280 x  960    2
											21: 1280 x 1024   16
											23: 1280 x 1024    2	*/

/* static  uint  gaport;	*/		/* GA-1024A/GA-1280A I/O-ıڽ */
/* static  volatile uchar far *ga_wind; */
									/* OtBbNEBhEAhX*/

uchar lut[] =  {0x00,0x00,0x00,0xff,0xff,0xff, 
				0x00,0x00,0x00,0x40,0x40,0x40,0x80,0x80,0x80,
			    0xc0,0xc0,0xc0,0xff,0xff,0xff};

      				      			/* pbgf|^ */
static	int	plane8;					/* color mode ?	  */

/* 				---- End of Data for GA-1024A/1280A ---					*/

char *bmp_file = "tmp%04d.bmp";		/* default BMP filename */

			/*	Position to print page numbers */
#define	PAGE_POS_X	 	 3
#define	PAGE_POS_Y	 	 6
#define	PAGE_ST_LENGTH	 8		/* maximal length by byte */
#define	PAGE_ST_HEIGHT	24
#define	LINE2			24

#define	MAX_VIEW		16

static int v_shift1 = 1;
static int h_shift1 = 1;
static int device_ga;
BOOL view_only;
static int view_key;

int	f_machine_unique;

static	int g_width;	/* width of screen by pixel		*/
static	int g_width_b;	/* width of screen by byte		*/
static	int g_height;	/* height of screen by pixel	*/

#if	USE_98RAM
#define	gvram0()	outp( 0xa6, 0 )		/* write GVRAM0 */
#define	gvram1()	outp( 0xa6, 1 )		/* write GVRAM1 */
#define GRAM_BUF    uchar far
#define G_TOP       0xa8000000L
#define	G_SEG		0xa800
#define	G_ID		0xafff0008L
#define	T_ID		0xa1000008L
#endif

#ifndef	NEMS
int view_EMS_top;
int view_EMS_unit;
extern int system_EMS_end;
int set_ems( int );
#endif

const char *const title_comment = TITLE_COMMENT;
extern int resume_info;
extern int unit_pages;
extern int slow_fact;
extern int slow_fact2;
extern int slow_page;
extern int v_shift0;
extern int fore_color;
extern int back_color;
extern BOOL normal_16color;
extern BOOL f_reverse;
extern BOOL f_resume;
extern BOOL f_use_new_size_option;
extern int num_view_buf;
extern int num_view;

extern int test_flg;

struct VIEW {
	int current;		/* current screen to be saved	*/
	int total;			/* total screen saved			*/
	int page[MAX_VIEW];	/* page numbers for screens		*/
	int w[MAX_VIEW];	/* width of screens				*/
	int h[MAX_VIEW];	/* height of screens			*/
};
static struct VIEW view;

struct SCROLL {
	/* output parameter. send to scroll-functions and other device-output-
     * functions
     */
	int x;
	int y;
	/* the current positioin in bitmap. */
	int gw_act, gh_act;
	/* width and height to output on screen */
	BOOL x_lock, y_lock;
	/* permition to scroll horizontal and vertical direction. */
	HUGE_BUF *mptr;
	/* the current position of bitmap pointer */
	int h_spc, v_spc;
	/* h_spc and v_spc is to put at the center of the screen */
	int h_spc8, gw_act8;
	/* h_spc8 = h_spc*8, gw_act8 = gw_act*8 is pixel */
	int page, part;
};

typedef enum {
	BackSpace, SpaceKey,	/* PreviousPart, NextPart   */
	Key_P, Key_N,	/* PreviousPage, NextPage   */
	CaridgeReturn,	/* NextPageDirection        */
	EscapeKey,	/* EscapeQuit               */
	Key_Q,	/* Same as above            */
	Key_B,	/* Another Previous Page	*/
	Key_V,	/* View outline				*/
	Key_C,	/* Comressed View			*/
	Key_R,	/* Reverse					*/
	Key_H,	/* HELP 					*/
	HELP,	/* Help key					*/
	Key_M,	/* Move to a page			*/
	Key_G,	/* Same as above			*/
	ArrowDown, ArrowUp, ArrowLeft, ArrowRight,
	LoopEnd, ShiftKey,
	ShiftDown, ShiftUp, ShiftLeft, ShiftRight,
	UNKNOWN_KEY
} KeyInput;

static unsigned int key_data[] =
{
	0x0140, 0x0610,
	0x0302, 0x0540,
	0x0310,
	0x0001,
	0x0201,
	0x0520,
	0x0510,
	0x0508,
	0x0208,
	0x0404,
	0x0780,
	0x0580,
	0x0402,
	0x0720, 0x0704, 0x0708, 0x0710,
	0x0000, 0x0e01
};

/*	These variables are not used */
int s_max_width = 118 * 8;
int s_max_height = 118 * 11;
int f_center;

static HUGE_BUF *map_top_ptr;

/* pointer of bitmap buffer */
static PIXEL vmax, hmax, hmaxb;
static PIXEL bvmax, bhmax;

/* head pointer of graphic vram */
static int f_div;
static int f_div2;
static int div_y;

/* static int	view_page; */
static BUFFER *v_top;
static BUFFER *v_top2;
static HUGE_BUF *view_buf;

long view_buf_size;

int x_shift;
int y_shift;

/* Proto-types */

/*	buffer.c */
void clear_buf(BUF_INFO *);
ulong leftbuffer(void);

NEXT_ACTION device_out(OUTPUT_INFO *, DIMENSION *);

/* 				--- Device dependent functions ---						*/

void set_disp_reso(void);
void device_init(DIMENSION *);
void device_pause(void);
void device_cont(void);
void device_clear(OUTPUT_INFO *);
void device_end(void);
void pr_new_page(void);

static KeyInput extra_inkey(int);
static void use_text_screen(int);

static void Gbitblt(int x, int y, int length, char far *s);
static void Gbitblt256(int x, int y, int length, char far* src);
static void GclrScreen(void);
static void GputStr(int x, int y, char *s);
static void ReverseScreen(int);

#if	BLOCK_MOVE
/* following functions can be replaced by draw_screen() */
static void GcopyImage(int, int, int, int, int, int, struct SCROLL *);

/* 			--- End of Device dependent functions ---					*/

static void s_up(struct SCROLL *, int);
static void s_down(struct SCROLL *, int);
static void s_left(struct SCROLL *, int);
static void s_right(struct SCROLL *, int);
#else
#define	s_up(s,x)		draw_screen(s)
#define	s_down(s,x)		draw_screen(s)
#define	s_left(s,x)		draw_screen(s)
#define	s_right(s,x)	draw_screen(s)
#endif

/* the following functions are device independent if USE_98RAM = 0 */
void slow(int fact);
static void first_draw(struct SCROLL *);
static void draw_screen(struct SCROLL *);
static void move_screen(struct SCROLL *, KeyInput);
static void scroll_up(struct SCROLL *);
static void scroll_down(struct SCROLL *);
static void scroll_right(struct SCROLL *);
static void scroll_left(struct SCROLL *);
static void msg_help(void);
static void cls_page_num(void);
static void pr_page_num0(struct SCROLL*);
static void pr_page_num(int, int, int, int);
static int  get_view(int, int);
static void s_view(int, HUGE_BUF*);
static KeyInput trans_key(char);


#if	BLOCK_MOVE
static void GcopyImage(int x1, int y1, int x2, int y2, int x3, int y3, 
	struct SCROLL *s_dat)
/* 	move a rectangular region within a graphic window 		*/
{
	int	x, y;
	x = s_dat->h_spc8;
	y = s_dat->v_spc;
	GAcopyImage(x + x1, y + y1, x + x2, y + y2, x + x3, y + y3);
}
#endif

static void GclrScreen(void)
/* clear Graphic Screen */
{
	GAclrScreen();
}

static void GputStr(int x, int y, char *s)
{
	GAputStr(x, y, s, 1, 0, 1);
}

static void Gbitblt256(int x, int y, int length, char far* src)
{
	GArestoreImage(x, y, x+length-1, y, PIXEL_MODE, src); 
}

static void Gbitblt(int x, int y, int length, char far* src)
/* put rater data with length pixel from (x,y) */
{
#if	!USE_ASM
	int	c, k, count;
	uchar *buf8;
#endif
	if (plane8){
#if	USE_ASM
		asm	les	 bx, dword ptr src;
		asm	mov	 di, length;
		asm	add	 di, 7;
		asm	mov	 si, offset common_work;
		asm	jmp	 short check;
start:	asm mov	 al, es:[bx];
		asm	inc	 bx
		asm	mov	 cx, 8
count8:	asm	xor	 ah, ah;
		asm	add	 ax, ax
		asm	mov  ds:[si], ah;
		asm	inc	 si;
		asm	loop count8
check:	asm	sub	 di, 8;
		asm	jge	 start;
#else
		count = length;
		buf8 = common_work;
		k = 0;

		while (--count >= 0){
			if (!(k >>= 1)){
				k = 0x80;
				c = *src++;
			}
			*buf8++ = (c & k)? 1:0;
		}
#endif
		Gbitblt256(x, y, length, common_work); 
	}else
		GArestoreImage(x, y, x+length-1, y, PLANE_MODE, src);
}

#if	BLOCK_MOVE
static void s_up(struct SCROLL *s_dat, int v_shift)
	/* X[XEXN[EAbv by v_shift dots */
{
	int	 i;
	HUGE_BUF *mptr_tmp;

	GcopyImage(0, v_shift, s_dat->gw_act8 - 1, s_dat->gh_act - 1, 0, 0, s_dat);
	mptr_tmp = s_dat->mptr + (ulong)hmaxb *(g_height - v_shift);
	for (i = s_dat->gh_act - v_shift; i < s_dat->gh_act; i++ ){
		Gbitblt(s_dat->h_spc8, s_dat->v_spc + i, s_dat->gw_act8,
		 	(char far*) mptr_tmp);
		mptr_tmp += (ulong)hmaxb;
	}
}

static void s_down(struct SCROLL *s_dat, int v_shift)
	/* X[XEXN[E_E by v_shift dots */
{
	int	 i;
	HUGE_BUF *mptr_tmp;

	GcopyImage(0, 0, s_dat->gw_act8 -1, s_dat->gh_act - v_shift - 1,
		0, v_shift, s_dat);
	mptr_tmp = s_dat->mptr;
	for (i = 0; i < v_shift; i++ ){
		Gbitblt(s_dat->h_spc8, s_dat->v_spc + i, s_dat->gw_act8,
			(char far*) mptr_tmp);
		mptr_tmp += (ulong)hmaxb;
	}
}

static void s_right(struct SCROLL *s_dat, int h_shift)
	/* @X[XEXN[ by h_shift byte */
{
	int	 i;
	HUGE_BUF *mptr_tmp;

	GcopyImage(0, 0, s_dat->gw_act8 - h_shift - 1, s_dat->gh_act - 1,
		h_shift, 0, s_dat);
	mptr_tmp = s_dat->mptr;
	for (i = 0; i < s_dat->gh_act; i++){
		Gbitblt(s_dat->h_spc8, s_dat->v_spc + i, h_shift,
			(char far*) mptr_tmp);
		mptr_tmp += (ulong)hmaxb;
	}
}


static void s_left(struct SCROLL *s_dat, int h_shift)
	/* E@X[XEXN[ by h_shift byte */
{
	int	 i;
	HUGE_BUF *mptr_tmp;

	GcopyImage(h_shift, 0, s_dat->gw_act8 - 1, s_dat->gh_act - 1,
		0, 0, s_dat);
	mptr_tmp = s_dat->mptr + s_dat->gw_act - h_shift/8;
	for (i = 0; i < s_dat->gh_act; i++){
		Gbitblt(s_dat->h_spc8 + s_dat->gw_act8 - h_shift,
			s_dat->v_spc + i, h_shift,
			(char far*)mptr_tmp);
		mptr_tmp += (ulong)hmaxb;
	}
}
#endif

void pr_new_page()
/* This is called in case of a new page */
{
}

static KeyInput trans_key(char ch)
{
	static char code[] = "\b pn\r\x1b" "qbvcrh mg";
	char *p;
	KeyInput key_d;

	if((p = strchr(code, tolower(ch))) == NULL || !*p)
		return UNKNOWN_KEY;
	key_d = (KeyInput)(p - code);
	if (key_d == Key_G)
		key_d = Key_M;
	else if (key_d == Key_Q)
		key_d = EscapeKey;
	else if (key_d == Key_B)
		key_d = Key_P;
	return key_d;
}

static KeyInput
    extra_inkey(int num0)
	/* realtime key scanning. waiting until one of KeyInput is pressed.
     * and if the key is a cursor-key, I check at the same time whether Shift-
     * key is hit or not.
     */
{
	void flskey(void);

#if 1
	const int intno = 0x18;
	int num;
	int f_num;
	union REGS inregs, inregs2, outregs;
	KeyInput key_d;

	inregs.h.ah = 0x04;
	inregs2.h.ah = 0x00;
	if((f_num = num = num0) >= 1)
		unit_pages = num;

	while (TRUE) {
		for (key_d = ArrowDown; key_d != LoopEnd; (int)key_d++) {
			inregs.h.al = (uchar)(key_data[(int)key_d] >> 8);
			int86(intno, &inregs, &outregs);
			if (outregs.h.ah & (uchar)key_data[(int)key_d]) {
				inregs.h.al = (uchar)(key_data[(int)ShiftKey] >> 8);
				int86(intno, &inregs, &outregs);
				if (outregs.h.ah & (uchar)key_data[(int)ShiftKey])
					key_d = (KeyInput) ((int)key_d - (int)ArrowDown +
										(int)ShiftDown);
				return key_d;
			}
		}
		flskey();
		int86(intno, &inregs2, &outregs);
		if (outregs.h.al >= '0' && outregs.h.al <= '9') {
			f_num = 1;
			num -= (num / 100) * 100;
			num = num * 10 + outregs.h.al - '0';
			if (num >= 1)
				unit_pages = num;
		} else {
			if((key_d = trans_key(outregs.h.al)) != UNKNOWN_KEY){
				if (key_d == Key_M && f_num == 0)
					continue;
				return key_d;
			} else if (outregs.h.ah == 0x3f) {	/* scan code == HELP key */
				return HELP;
			}
			f_num = num = 0;
		}
	}
#else
	const int intno = 0x18;
	int num;
	int f_num;
	union REGS inregs, inregs2, outregs;
	KeyInput key_d;

	inregs.h.ah = 0x04;
	inregs2.h.ah = 0x01;
	key_d = (KeyInput) 0;
	if((f_num = num = num0) >= 1)
		unit_pages = num;
resume:
	while (TRUE) {
		int86(intno, &inregs2, &outregs);
		if (outregs.h.bh > 0) {
			if (outregs.h.al >= '0' && outregs.h.al <= '9') {
				f_num = 1;
				num -= (num / 100) * 100;
				num = num * 10 + outregs.h.al - '0';
				if (num >= 1)
					unit_pages = num;
			}
			flskey();
		}
		inregs.h.al = (uchar)(key_data[(int)key_d] >> 8);
		int86(intno, &inregs, &outregs);
		if (outregs.h.ah & (uchar)key_data[(int)key_d])
			break;
		if ((KeyInput) (((int)key_d)++) == LoopEnd)
			key_d = (KeyInput) 0;
	}
	/* check Shift+CursorKey ... */
	if ((int)key_d >= (int)ArrowDown && (int)key_d <= (int)ArrowRight) {
		inregs.h.al = (uchar)(key_data[(int)ShiftKey] >> 8);
		int86(intno, &inregs, &outregs);
		if (outregs.h.ah & (uchar)key_data[(int)ShiftKey])
			key_d = (KeyInput) ((int)key_d - (int)ArrowDown +
								(int)ShiftDown);
	}
	else {
		if (key_d == Key_G)
			key_d = Key_M;
		else if (key_d == Key_B)
			key_d = Key_P;
		else if (key_d == Key_Q)
			key_d = EscapeKey;
		else if (key_d == Key_M && f_num == 0)
			goto resume;
	}
	return (key_d);
#endif
}

void device_pause(void)
/*	Change to text screen.  This is called in case or HELP/Error */
{
	if(device_ga){
		GAcrtSel(CRT_PC);
		device_ga = 0;
	}
}


void device_cont(void)
/* recover from device_pause() */
{
	if(!device_ga){
		GAcrtSel(CRT_GA);
		device_ga = 1;
	}
}

void set_disp_reso(void)
/* This is called before defining buffer size */
{
	struct VDCONFIG vd;

	if ((disp_reso >= 13 && disp_reso <= 15) || disp_reso > 23)
		error(ILLEGAL_ARGS, "-reso=%d", disp_reso);
	if (GAinit(disp_reso))
		error(DEVICE_FAULT,"NO GAINIT");
	GAgetVideoConfig((void far *)&vd);

/*	gaport = vd.port ;	*/ /* GA-1024A/GA-1280A WX^̃|[gԍ */
/*	ga_wind = (void far *) ((ulong)vd.ga_seg << 16); */
						/* ̨س޳ڽ */
	g_width_b = (g_width = vd.scr_width)/8;
	g_height = vd.scr_height;

	if (disp_reso <= 0){
		switch(g_width){

			case 640:	disp_reso = (!disp_reso)?LRESO_2C:LRESO_16C;
						break;
			case 800:	disp_reso = (!disp_reso)?MRESO_2C:MRESO_16C;
						break;
			case 1024:	disp_reso = (!disp_reso)?HRESO_2C:HRESO_16C;
						break;
			case 1280:	if(g_height == 960)
							disp_reso = (!disp_reso)? 19:17;
						else
							disp_reso = (!disp_reso)? 23:21;
						break;
			default:	error(DEVICE_FAULT,
							"Not supported:%dx%d", g_width, g_height);
		}
		GAinit(disp_reso);
	}
	if (disp_reso != LRESO_2C && disp_reso != MRESO_2C && disp_reso != HRESO_2C
	 && disp_reso != 19 && disp_reso != 23)
		plane8 = 1;
	else if((uint)vd.ga_seg == 0xf000)
		plane8 = 2;
	GAgetVideoConfig((void far *)&vd);
	if(test_flg < 2)
		printf(
"res: %d x %d   plane: %d   port: %02X   seg: %04X   io: %02X   mem: %dM\n",
		vd.scr_width, vd.scr_height, vd.plane, vd.port, vd.ga_seg, 
		vd.gainit_int, vd.ga_vram);
	GAeraseCursor();
	GclrScreen();
	ReverseScreen(f_reverse);	/* 1-st screen */
	view_buf_size = (long)g_width_b*g_height/2;
	if (view_buf_size > 0x10000L)
		view_buf_size = 0x10000L;
}

void device_init(DIMENSION *dim)
/* This is called only once after defining buffer */
{
	int	i, j, unit;
#if	USE_98RAM
	uint far *gvram_last = (uint far *)G_ID;
#endif

	if (v_shift0 < 0 ){
		if((v_shift1 = -v_shift0) > 128) v_shift1 = 128;
		v_shift0 = 0;
	}
	if (slow_fact2 < 0)
		if((h_shift1 = -slow_fact2) > 16) h_shift1 = 16;
#if	USE_98RAM
	if (f_resume) {
		if (*gvram_last-- == (((uint)'P') << 8) + 'D'
		  && *(gvram_last-1) == resume_info) {
			dim->start_page = *gvram_last;
		}
		else {
			if (*((uint far *)(T_ID + 2)) == (((uint)'O') << 8) + 'D'
		 	  && *((uint far *)(T_ID - 2)) == resume_info) {
				dim->start_page = *((uint far *)T_ID);
			}
		}
	}
#endif

	bhmax = dim->buf_width;
	bvmax = dim->buf_height;
	if (dim->split == 1){
		i = (g_width_b - 4)*8;
		j = g_height;
		for ( f_div = 2; f_div < 8; f_div <<= 1 ){
			if (bhmax < i*f_div && bvmax < j*f_div) break;
		}
		f_div2 = f_div;
		if (bhmax >= i*f_div/2)
			f_div2 *= 2;
		div_y  = g_height - bvmax/f_div;
		if(div_y > 30) div_y/=2;
		else if(div_y) div_y--;
	}
	else
		view_only = FALSE;
	if (f_div2){
		view_buf_size = (long)(bhmax/8/f_div2+1)*(bvmax/f_div2+1);
		if (view_buf_size > 0x10000L)
			view_buf_size = 0x10000L;
		unit = (view_buf_size + 0x3fff)/0x4000;
	}
	device_cont();
	if (!f_div2 || f_div2 > 8)
		num_view = 0;
#if	USE_98RAM
	if (num_view == -0x7fff) {			/* check 2nd GVRAM */
		i = *((uint far *)G_TOP);
		(void)gvram1();
		*((uint far *)G_TOP) = i + 1;
		(void)gvram0();
		if (i != *((uint far *)G_TOP))
			num_view = 0;
		else{
			view_buf = (HUGE_BUF *)G_TOP;
			if( (num_view_buf = 0x18000L/view_buf_size) > MAX_VIEW )
			num_view_buf = MAX_VIEW;
		}
	}
#endif
#ifndef	NEMS
	if (num_view < 0 && num_view >= -MAX_VIEW){
		if (unit < view_EMS_unit){
			num_view = -view_EMS_unit*num_view_buf/unit;
			if (num_view < -MAX_VIEW)
				num_view = -MAX_VIEW;
		}
		num_view_buf = -num_view;
		view_EMS_top = system_EMS_end;
		max_user_page -= view_EMS_unit*num_view_buf;
		system_EMS_end += view_EMS_unit*num_view_buf;
		view_buf = pf_addr;
		return;
	}
#endif
	if (num_view > 0){
		if (num_view_buf > MAX_VIEW) num_view_buf = MAX_VIEW;
		num_view_buf = (int)((leftbuffer() - 0x80L) / view_buf_size);
		if (num_view < num_view_buf) num_view_buf = num_view;
		if (num_view_buf)
			view_buf = (HUGE_BUF *)
				farmalloc(view_buf_size * (num_view = num_view_buf));
	}
	else if (!num_view)
		num_view_buf = view_EMS_unit = 0;
}

static void ReverseScreen(int mode)
{
	int	i, pal;
	if(mode) mode = 1;
	GAsetPalette((void far *)&lut[0],mode);
	GAsetPalette((void far *)&lut[3],1-mode);

	if(plane8 & 1){
		pal = (mode)?6:2;
		for (i = 6; i < 21; i += 3){
			GAsetPalette((void far *)&lut[i],pal);
			if (mode) pal--;
			else	  pal++;
		}
	}
}

void device_end()
/* This is called when we quit from dviout  */
{
#if	USE_98RAM
	*(((uchar far *)(G_ID)) + 1) = 'P';
#endif

	GclrScreen();
	device_pause();
	GAterm(PAL_DEF);	/* I֐ */
}

void device_clear(OUTPUT_INFO *out)
/* This is called at the renewal of the virtual Graphic screen */
{
	/* intialize variables */
	map_top_ptr = out->bitmap_ptr;
	hmax = out->width;
	vmax = out->height;
	hmaxb = out->byte_width;
}

static void s_view(int div, HUGE_BUF *dest)
{
	uint ch0, ch;
	int i, j, vm, v, w, divm, divp, divs, div_x;
	HUGE_BUF *ptr0;
	BUFFER *ptr1;
	BUFFER *ptr;
	uchar *ptrg;
	uchar line_buf[COMMON_SIZE/8];
#if	GRAY_TABLE
	uint trans[16];
	uint *ptri;
#endif

	ptr0 = map_top_ptr;
	divm = div - 1;
	divp = 16/div - 1;
	divs = 1<<(8/div);
	w = (hmax+divm)/div;
	i = g_width;
	if (div >= f_div2) i /= 2;
	div_x = ((i - bhmax/div)/2 & 0xff0) + 8;

#if	GRAY_SCALE
	if ((plane8 & 1)&& div == 2 && dest == NULL){
 #if GRAY_TABLE
		for(i = 0, ptri = &trans[0]; i < 16; i++, ptri++){
			*ptri = (i & 8)?1:0;
			if (i & 4) *ptri += 1;
			if (i & 2) *ptri += 0x100;
			if (i & 1) *ptri += 0x100;
		}
 #endif
		for (ch = v = 0; v < vmax; v += div) {
			vm = ((vmax - v) < div) ? vmax - v : div;
			ptr1 = (BUFFER *)ptr0;
			ptr0 += hmaxb*div;
 #if GRAY_TABLE
			ptri = (uint *)common_work;
			for (i = 0; i < hmaxb; i++) {
				ptri[1] = ptri[0] = 0x202;
				ptr = ptr1++;
				for (j = vm; j != 0; j--) {
					ptri[0] += trans[*ptr >> 4];
					ptri[1] += trans[*ptr & 0x0f];
					ptr += hmaxb;
				}
				ptri += 2;
			}
 #else
			ptrg = common_work;
			for (i = 0; i < hmaxb; i++) {
				ptrg[3]= ptrg[2] = ptrg[1] = ptrg[0] = 2;
				ptr = ptr1++;
				for (j = vm; j != 0; j--) {
					if (((ch0 = *ptr) & 0xc0) != 0){
						*ptrg += 1;
						if ((ch & 0xc0) == 0xc0)
							*ptrg += 1;
					}
					if (ch0 & 0x30){
						*(ptrg+1) += 1;
						if ((ch0 & 0x30) == 0x30)
							*(ptrg+1) += 1;
					}
					if (ch0 & 0x0c){
						*(ptrg+2) += 1;
						if ((ch0 & 0x0c) == 0xc0)
							*(ptrg+2) += 1;
					}
					if (ch0 & 0x03){
						*(ptrg+3) += 1;
						if ((ch0 & 0x03) == 0x03)
							*(ptrg+3) += 1;
					}
					ptr += hmaxb;
				}
				ptrg += 4;
			}
 #endif
			Gbitblt256(div_x, div_y + v/div, w, (char far*)common_work); 
		}
		return;
	}
#endif

	for (ch = v = 0; v < vmax; v += div) {
		vm = ((vmax - v) < div) ? vmax - v : div;
		ptr1 = (BUFFER *)ptr0;
		ptr0 += hmaxb*div;
		ptrg = line_buf;

		for (i = 0; i < hmaxb; i++) {
			ptr = ptr1++;
			for (j = vm; j != 0; j--) {
				switch(div){
					case 2:
							if (((ch0 = *ptr) & 0xc0) != 0) {
								ch |= 8;
							}
							if ((ch0 & 0x30) != 0) {
								ch |= 4;
							}
							if ((ch0 & 0x0c) != 0) {
								ch |= 2;
							}
							if ((ch0 & 0x03) != 0) {
								ch |= 1;
							}
							break;

					case 4:
							if ((*ptr & 0xf0) != 0) {
								ch |= 2;
							}
							if ((*ptr & 0x0f) != 0) {
								ch |= 1;
							}
							break;

					case 8:
							if (*ptr != 0){
								ch |= 1;
								goto nxt;
							}
							break;
				}
				if ((ch & divp) == divp)
					break;
				ptr += hmaxb;
			}
nxt:		if ((i & divm) == divm)
				*ptrg++ = ch;
			ch *= divs;
		}
		if (( i = (hmaxb & divm) ) != 0){
			while (i++ < divm)	ch *= divs;
			*ptrg++ = ch;
		}
		if (dest == NULL){
			Gbitblt(div_x, div_y + v/div, w, line_buf);
		}else{
			ptr = (BUFFER *)dest;
			dest += (j = (w+7)/8);
			for (i = 0; i < j; i++)
				*ptr++ = line_buf[i];
		}
	}
}

static void cls_page_num(void)
{
	GputStr(PAGE_POS_X, PAGE_POS_Y, "                                       ");
}

static void pr_page_num0(struct SCROLL *s_dat)
{
	pr_page_num(PAGE_POS_X, PAGE_POS_Y, s_dat->page, s_dat->part);
}

static void pr_page_num(int x, int y, int page, int part)
/* print page number at (x,y) */
{
	sprintf(common_work, (part>0)?"[%d-%d]":"[%d]", page, part);
	GputStr(x, y, common_work);
}

#if	GSAVE
#define	COL_CNT	2
typedef	unsigned short	WORD;
typedef	unsigned long	DWORD;

typedef	struct	tagBITMAPFILEHEADER {
	WORD	bfType;
	DWORD	bfSize;
	WORD	bfReserved1;
	WORD	bfReserved2;
	DWORD	bfOffBits;
} BITMAPFILEHEADER;

typedef	struct	tagBITMAPINFOHEADER {
	DWORD	biSize;
	DWORD	biWidth;
	DWORD	biHeight;
	WORD	biPlanes;
	WORD	biBitCount;
	DWORD	biCompression;
	DWORD	biSizeImage;
	DWORD	biXPelsPerMeter;
	DWORD	biYPelsPerMeter;
	DWORD	biCirUsed;
	DWORD	biCirImportant;
} BITMAPINFOHEADER;

BITMAPFILEHEADER bf = {
	0x4d42,				/* ID ('B', 'M') */
	0x00000000,			/* file size */
	0x0000,				/* reserved */
	0x0000,				/* reserved */
	sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + COL_CNT * 4
};

BITMAPINFOHEADER bi = {
	sizeof(BITMAPINFOHEADER),	/* header size */
	0x00000000,			/* width */
	0x00000000,			/* height */
	0x0001,				/* planes */
	0x0001,				/* bit count */
	0x00000000,			/* compression */
	0x00000000,			/* size of image */
	0x00000000,			/* x-resolution */
	0x00000000,			/* y-resolution */
	COL_CNT,			/* color index count */
	0x00000000			/* important index count */
};

uchar col_idx[8] = {0xff, 0xff, 0xff, 0, 0, 0, 0, 0};
					/* palette data */
#endif

static int get_view(int div, int page)
{
	int i, pt, pg, w, wb, h, div_x;
	HUGE_BUF *buf_tmp;
#if	GSAVE
	int	mode, scan;
	FILE *fp;
#endif

	s_view(div, NULL);
	pr_page_num(PAGE_POS_X, PAGE_POS_Y, page, 0);
	GputStr(PAGE_POS_X+90, PAGE_POS_Y,(view_only)?"view":"     ");
	pt = view.current;
	pg = -1;
	while (TRUE) {
		if (div != f_div2)
			goto skip;
		if (--pt < 0)
			pt = view.total - 1;
		if (pt >= 0) {
			GputStr(g_width/2 + PAGE_POS_X, PAGE_POS_Y, "         ");
#ifndef	NEMS
			if( view_EMS_unit ){
				buf_tmp = view_buf;
				set_ems( view_EMS_top + view_EMS_unit * pt );
			}
			else
#endif
				buf_tmp = view_buf + view_buf_size * pt;
			wb = ((w = view.w[pt])+7)/8;
			h = view.h[pt];
			div_x = ((g_width*3/2 - bhmax/div)/2 & 0xff0) + 8;
#if	USE_98RAM
			if (num_view == -0x7fff)	(void)gvram1();
#endif
			for ( i = 0; i < h; i++ ){
				Gbitblt(div_x, div_y + i, w, (char far*)buf_tmp);
				buf_tmp += wb;
			}
#if	USE_98RAM
			if (num_view == -0x7fff)	(void)gvram0();
#endif
			pr_page_num(g_width/2 + PAGE_POS_X, PAGE_POS_Y,
				pg = view.page[pt], 0);
		}
skip:	view_key = tolower((uchar)getch());
		if (view_key != 'm' && view_key != '')
			pg = -1;
		if (view_key == 'k')
			GputStr(PAGE_POS_X+90, PAGE_POS_Y,
				(view_only = (view_only)?FALSE:TRUE)?
				"view":"      ");
#if	GSAVE
		if (view_key == 's'){
			if ((scan = (hmax + 31)/8 & 0xfffc) > COMMON_SIZE) goto ex;
			for (i=1; i < 4; i++)
				common_work[scan - i] = 0;
			bi.biWidth = (DWORD)hmax;
			bi.biHeight = (DWORD)vmax;
			bi.biSizeImage = scan * bi.biHeight;
			bf.bfSize = bf.bfOffBits + bi.biSizeImage;
			sprintf(common_work, bmp_file, page);
			if((fp = fopenf(common_work, "wb")) == NULL) goto ex;
			sprintf(common_work + 0x100,
				"Saving page %d in %s", page, common_work);
			GclrScreen();
			GputStr(g_width/4, g_height/2, common_work + 0x100);
			GputStr(g_width/4, g_height/2+LINE2, "Push any key to Continue!");
			fwrite((char *)&bf, sizeof bf, 1, fp);
			fwrite((char *)&bi, sizeof bi, 1, fp);
			for(i=0; i<3; i++){
				mode = f_reverse?6:2;
				col_idx[mode-i]  =lut[i];
				col_idx[8-mode-i]=lut[i+3];
			}
			fwrite((char *)&col_idx[0], sizeof col_idx, 1, fp);
			buf_tmp = map_top_ptr +  (long)hmaxb*(vmax-1);
			for (i = 0; i < vmax; i++){
				movedata(FP_SEG(buf_tmp), FP_OFF(buf_tmp),
				  FP_SEG(common_work), FP_OFF(common_work), hmaxb);
				fwrite(common_work, scan, 1, fp);
				buf_tmp -= hmaxb;
			}
			fclose(fp);
			(void)getch();
		}
		if (view_key != 'v' && view_key != '')
			break;
ex:		/* */
#endif
	}
	if (div != f_div2 || !num_view_buf)
		return 0;
	for (pt = view.total; pt > 0;) {
		if (view.page[--pt] == page) {
			view.current = pt + 1;
			goto nxt;
		}
	}
	if (view.total < num_view_buf)
		view.current = view.total++;
	if (view.current >= num_view_buf)
		view.current = 0;
	view.page[view.current] = page;
	w = view.w[view.current] = (hmax+div-1)/div;
	h = view.h[view.current] = (vmax+div-1)/div;
	if ((long)(w+7)/8*h > view_buf_size){
		num_view_buf = 0;
		goto nxt;
	}
#ifndef	NEMS
	if( view_EMS_unit ){
		buf_tmp = view_buf;	
		set_ems( view_EMS_top + view_EMS_unit*view.current );
	}else
#endif
		buf_tmp = view_buf + view_buf_size * view.current;
#if	USE_98RAM
	if (num_view == -0x7fff)	(void)gvram1();
#endif
	s_view(div, buf_tmp);
#if	USE_98RAM
	if (num_view == -0x7fff)	(void)gvram0();
#endif
	view.current++;
nxt:
	if (pg >= 0)
		unit_pages = pg;
	return pg+1;
}


static void use_text_screen(int mode)
/* mode = 1: graphic mode
   mode = 0: text mode without cursor */
{
	void clear_text_screen(void);
	void cursor_mode(int);
	void program_screen_mode(int);

	if (!mode) device_cont();
	clear_text_screen();
	cursor_mode(1 - mode);
	program_screen_mode(mode);
	if (mode) device_pause();
}


static void msg_help()
{
	use_text_screen(1);
	fprintf(stderr,
			"\x1b" "[5;H"
			"\t\t\t\t<<< Help >>>\n\n"
			"\t(SHIFT + )    \t: Scroll in a page\n"
			"\tN\t\t\t: Next page\n"
			"\tP, B\t\t\t: Previous page\n"
			"\tG, M\t\t\t: Move to a page\n"
			"\tnumbers\t\t\t: pages (skipped) by next B, G, M, N, P\n"
			"\tSpace\t\t\t: Next part\n"
			"\tBack Space\t\t: Previous part\n"
			"\tC, V\t\t\t: (Compressed) View outline\n"
			"\t\t\t\t  -> K:  keep View mode(toggle)\n"
			"\t\t\t\t  -> S:  Save in a BMP file\n"
			"\tR\t\t\t: Reverse Screen(toggle)\n"
			"\tH, Help\t\t\t: Help message\n"
			"\tReturn\t\t\t: Next block or quit\n"
			"\tQ, Escape\t\t: Quit\n"
		);
	getch();
	use_text_screen(0);
}

void slow(int fact)
{
	int	  i, j;

	i = (fact<6)?5:fact;
	while(fact-- > 0){
		for(j = 0; j < 6*i; j++) slow( 0 );
	}
}

NEXT_ACTION device_out(OUTPUT_INFO *out, DIMENSION *dim)
{
	static struct SCROLL s_dat;
	KeyInput key;
	static KeyInput last_key;
	int i, j, num;

	s_dat.mptr = out->bitmap_ptr;
	s_dat.mptr = map_top_ptr;
	s_dat.page = out->page;
	s_dat.part = (dim->split==1)?0:out->split;

	first_draw(&s_dat);
	slow(slow_page);
	if (view_only){
		key = last_key;
		cls_page_num();
		goto dispv;
	}
	for (num = 0;;) {
		key = extra_inkey(num);
		num = 0;
		if (view_only){
			if( (key >= ArrowDown && key <= ArrowRight)
			  ||(key >= ShiftDown && key <= ShiftRight))
				continue;
		}
rep:	switch (key) {
		  case Key_V:
		  case Key_C:
			  last_key = key;
			  if (!f_div) break;
			  GclrScreen();
dispv:		  if (key != Key_C || f_div == 8)
				j = get_view(f_div, out->page);
			  else
				j = get_view(f_div*2, out->page);
			  if (view_only){
				GputStr(PAGE_POS_X + 48, PAGE_POS_Y, "->");
				if(view_key >= '0' && view_key <= '9'){
					num = view_key - '0';
					continue;
				}
				if ((key = trans_key(view_key)) == UNKNOWN_KEY
				  || key == Key_V)
					break;
				goto rep;
			  }
			  GclrScreen();
			  if (j) goto disp_m;
disp_0:		  draw_screen(&s_dat);
			  slow(slow_page);
			  break;
		  case Key_R:
			  f_reverse = (f_reverse == TRUE) ? FALSE : TRUE;
			  ReverseScreen(f_reverse);
			  while (kbhit())
				  getch();
			  goto disp2;
		  case Key_H:
		  case HELP:
			  msg_help();
			  goto disp2;
		  case Key_M:
disp_m:		  unit_pages -= out->page;
			  return ((NEXT_ACTION)Key_N);
		  case ArrowDown:
			  scroll_up(&s_dat);
			  goto sl0;
		  case ArrowLeft:
			  scroll_right(&s_dat);
			  goto sl2;
		  case ArrowRight:
			  scroll_left(&s_dat);
sl2:		  slow(slow_fact2);
			  break;
		  case ArrowUp:
			  scroll_down(&s_dat);
sl0:		  slow(v_shift0);
			  break;
		  case ShiftUp:
		  case ShiftDown:
		  case ShiftLeft:
		  case ShiftRight:
			  move_screen(&s_dat, key);
disp2:		  slow(slow_fact);
			  break;
		  default:
			  return ((NEXT_ACTION)key);
		}
	}
}

static void first_draw(struct SCROLL *s_dat)
	/* at first, set variables and put to screen */
{
#if	USE_98RAM
	uint far *gvram_last = (uint far *)(G_ID - 4);

	*gvram_last++ = resume_info;
	*gvram_last++ = s_dat->page;
	*gvram_last++ = (((uint)'O') << 8) + 'D';	/* ID	   */
	*gvram_last++ = 0x239;		/* Version */
	*gvram_last++ = FP_OFF(s_dat);
	*gvram_last = FP_SEG(s_dat);

	if (f_resume) {
		*((uint far *)(T_ID - 2)) = resume_info;
		*((uint far *)T_ID) = s_dat->page;
		*((uint far *)(T_ID + 2)) = (((uint)'O') << 8) + 'D';	/* ID	   */
	}
#endif
	s_dat->x_lock = s_dat->y_lock = FALSE;

	if (hmaxb < g_width_b) {
		/* can't scroll horizontally */
		s_dat->gw_act = hmaxb;
		s_dat->x_lock = TRUE;
	}
	else
		s_dat->gw_act = g_width_b;
	s_dat->gw_act8 = s_dat->gw_act*8;

	if (vmax < g_height) {
		/* can't scroll vertically */
		s_dat->gh_act = vmax;
		s_dat->y_lock = TRUE;
	}
	else
		s_dat->gh_act = g_height;

	if ((s_dat->h_spc = g_width_b - s_dat->gw_act) < PAGE_ST_LENGTH*2){
		if (s_dat->h_spc < PAGE_ST_LENGTH)
			s_dat->h_spc = 0;
	}
	else
		s_dat->h_spc /= 2;
	if ((s_dat->v_spc = (g_height - s_dat->gh_act) / 2) <= PAGE_ST_HEIGHT
		|| s_dat->part > 1)
		s_dat->v_spc = 0;
	s_dat->h_spc8 = s_dat->h_spc*8;
	s_dat->x = -s_dat->h_spc;
	s_dat->y = -s_dat->v_spc;

	if (s_dat->part > 1)
		GclrScreen();
	if (!view_only){
		cls_page_num();
		draw_screen(s_dat);
		pr_page_num0(s_dat);
	}
}

static void draw_screen(struct SCROLL *s_dat)
	/* Move data from virtual Graphic Screen to Graphic Screen */
{
	int		i, j, k, c, wpm_save;
	HUGE_BUF *mptr_tmp;
	mptr_tmp = s_dat->mptr;

	for (i = 0; i < s_dat->gh_act; mptr_tmp += (ulong)hmaxb, i++){
		Gbitblt(s_dat->h_spc8, s_dat->v_spc + i, s_dat->gw_act8,
			(char far*)mptr_tmp);
	}
	if(s_dat->h_spc + s_dat->v_spc != 0)
		pr_page_num0(s_dat);
}

static void move_screen(struct SCROLL *s_dat, KeyInput direct)
{
	int x_step, y_step;

	x_step = y_step = 0;
	switch (direct) {
	  case ShiftDown:
		  y_step = (s_dat->gh_act) >> 1;
		  break;
	  case ShiftUp:
		  y_step = -((s_dat->gh_act) >> 1);
		  break;
	  case ShiftLeft:
		  x_step = -(s_dat->gw_act) >> 1;
		  break;
	  case ShiftRight:
		  x_step = (s_dat->gw_act) >> 1;
		  break;
	}

	if (x_step != 0 && !s_dat->x_lock) {
		if (s_dat->x + x_step <= 0)
			x_step = -s_dat->x;
		if (s_dat->x + x_step + g_width_b >= hmaxb)
			x_step = hmaxb - (s_dat->x + g_width_b);
		s_dat->x += x_step;
		s_dat->mptr += x_step;
		draw_screen(s_dat);
	}
	else if (y_step != 0 && !s_dat->y_lock) {
		if (s_dat->y + y_step <= 0)
			y_step = -s_dat->y;
		if (s_dat->y + y_step + g_height >= vmax)
			y_step = vmax - (s_dat->y + g_height);
		s_dat->y += y_step;
		s_dat->mptr += (long)y_step *hmaxb;
		draw_screen(s_dat);
	}
}

static void scroll_up(struct SCROLL *s_dat)
{
	int shift;

	if ((shift = vmax - s_dat->y - g_height) > 0) {
		if (shift > v_shift1)
			shift = v_shift1;
		s_dat->mptr += hmaxb * shift;
		s_dat->y += shift;
		s_up(s_dat, shift);
	}
}

static void scroll_down(struct SCROLL *s_dat)
{
	int shift;

	if ((shift = s_dat->y) > 0) {
		if (shift > v_shift1)
			shift = v_shift1;
		s_dat->mptr -= hmaxb * shift;
		s_dat->y -= shift;
		s_down(s_dat, shift);
	}
	else if(s_dat->x <= 0)
		pr_page_num0(s_dat);
}

static void scroll_right(struct SCROLL *s_dat)
{
	int	shift;

	if (s_dat->x > 0) {
		shift = (s_dat->x > h_shift1)? h_shift1:s_dat->x;
		s_dat->mptr -= shift;
		s_dat->x -= shift;
		s_right(s_dat, shift*8);
	}else if (s_dat->y <= 0)
		pr_page_num0(s_dat);
}

static void scroll_left(struct SCROLL *s_dat)
{
	int shift;

	if ((shift = hmaxb - s_dat->x - g_width_b) > 0) {
		if (shift > h_shift1) shift = h_shift1;
		s_dat->mptr += shift;
		s_dat->x += shift;
		s_left(s_dat, shift*8);
	}
}

static void flskey(void)
	/*  flush key-buffer. by calling dos function */
{
	bdos(12, 0, 0);
}

static void clear_text_screen()
	/* clear text screen */
{
	fprintf(stderr, "\x1b" "*");
}

static void program_screen_mode(int mode)
	/* to use the bottom line for user */
{
	fprintf(stderr, mode ? "\x1b" "[>1h" : "\x1b" "[>1l");
}

static void cursor_mode(int flg)
	/* Cursor on or off */
{
	fprintf(stderr, flg ? "\x1b" "[>5l" : "\x1b" "[>5h");
}
/* end of file : device.c */
