/*
 *  TEX Device Driver  ver 2.02-
 *  copyright(c) 1988, 1989 by TSG, 1990-1995 by SHIMA
 *  1991 changed by hideki
 *  1991 changed by T.Minagawa
 *
 *  init.c : initialize variables
 *      Apr. 29, 1989 : 1st edition
 *      Jun.  1, 1989 : 2nd edition
 *
 *  This module is a device-dependent one.
 *	modified for non PC-9801 by sempa 1992
 *             14 June 1992 : modified for tpic by Oh-Yeah?
 *
 *  modifed for LIPS3 by SHIMA, 30 June 1992
 *  modified for Hires-9801 by OkI 21 June 1992
 *  modified for pTeX `tate' mode,  6 August 1992  by Naochan!.
 *  slightly modified by OkI 8 August 1992 (pTeX & Hires & LIPS3)
 *  modified for ESC/Page by H.Tomiie, 20 August 1992
 *	modified for "-wait" option by sempa, 1 Sept 1992
 *	modified for LIPS3+ESC/Page by OkI & H.Tomiie 30 Sept. 1992
 *  slightly modified for NTTjTeX by Yakumo, 27 Nov. 1992
 *  slightly modified for NTTjTeX by Yakumo, 16 Dec. 1992
 *  modified for EMS by SHIMA, Dec 1992
 *  modified for LIPS Special commands  by Sadayuki Iwai 8 Nov. 1993
 */


/*
#define	DEBUG	1
*/
#define	USER_EMS_PAGES	4

#include <stdio.h>
#include <stdlib.h>
#include <dir.h>
#include <mem.h>
#include <alloc.h>
#include <string.h>
#include <ctype.h>
#include <io.h>
#include <dos.h>

#define _DEF_STDIO_H_
#include "dd.h"
#include "err.h"
#include "dviread.h"
#include "prtout.h"
#include "option.h"
#include "version.h"
#include "vfont.h"
#include "alloc.h"

void get_config(int, char **);
void initialize(DVIFILE_INFO *, DIMENSION *);

static void set_prt_type(DIMENSION *dim);
static void read_post(DVIFILE_INFO *);
static void pixel_init(DVIFILE_INFO *, DIMENSION *);

/* static void set_mag( DIMENSION* ); */
static void set_dimension(DVIFILE_INFO *, DIMENSION *);
static void make_page_index(DVIFILE_INFO *, DIMENSION *);
static ulong mult_long(ulong, ulong);
static void opt_cfg(char *);
static void youshi_size(char *);

/* option.c */
void set_option(ARG_TABLE *, int, char **);
void set_config(ARG_TABLE *, char *);
int make_path(char *path, char *dir, char *name, char *ext);

/* size.c, prtsize.c */
void set_convert(SIZE_PARA, int, int);
PIXEL sptopixel(SCALED_PT);
PIXEL vtopixel(SCALED_PT);
int set_size(PIXEL, PIXEL, PIXEL, PIXEL, PIXEL *, PIXEL *);

/* fontdef.c */
void make_font_list(DVIFILE_INFO *, DIMENSION *);

/* buffer.c */
void buffer_init(void);
ulong leftbuffer(void);
char *marea(int);
char *dup_string(char *);

/* decodepk.c */
void decode_init(void);

/* mult20.asm */
ulong mult20(ulong, ulong);

/* p_out.c */
void get_prt_ctl(char *fname);
#ifdef LBP
void set_LBP_prt_ctl(int hunit, int vunit);
#endif

/* stack.c */
void stack_init(int stack_max);

#ifndef NOTPIC
/* tpic.c */
void tpic_init(PIXEL buf_height);	/* alloc y-bucket[vmax] and activate */

#endif

/* vfont.c */
int get_vfont_name(char *cfg_name);

/* vfont.c escpage.c ^cXCb` Tomiie*/
#ifndef	NOTATEGAKI
int tategaki = 0;

#endif

#ifndef NO_NTTRPL
/* NTTjTeX->ASCII{TeX fontϊtO */
BOOL ntt_subst;
char *ntt_subst_fonts;

#endif

#ifndef NO_GENFONT
char *genfont_tmpl = NULL;
#endif

/* LBPv^[I΂Ă邱ƂtO */
BOOL f_lbp_prt;

int test_flg = -1;

/* -f 邩ǂ */
static BOOL mag_half = FALSE;

/* -half 邩ǂ */
static int opt_mag = -1;

/* -mag ɂĎw肳ꂽ */
static BOOL f_center = FALSE;

/* centering */
BOOL dvifile_page = FALSE;

#ifdef JDWN
/* pret.c */
extern DJTABLE* dj;
#endif

#ifndef	NEMS
extern int system_EMS_end;
extern int max_user_page;

int system_ems[] =
	{
		USER_EMS_PAGES,		/* user_ems */
		0,					/* for download table */
		-1
	};
#endif

#ifndef NNSZ
extern int length_to_dot(char *, int *, int);
#endif

int enlarge;
static int add_width;
static int add_height;
static char *ff_flg_str;

/* by K.Yoshizawa  Dec. 26, 1992 */
BOOL f_use_new_size_option = TRUE;
/* A4 :  210mm x 297mm */
static SCALED_PT PW = MM_TO_SP(210);	/* p̉ */
static SCALED_PT PH = MM_TO_SP(297);	/* p̏c */
static SCALED_PT TM = -1L;				/* p[̃}[W */
static SCALED_PT BM = -1L;				/* p[̃}[W */
static SCALED_PT LM = -1L;				/* p[̃}[W */
static SCALED_PT RM = -1L;				/* pE[̃}[W */
static SCALED_PT MW;					/* 󎚉\̍ő剡 */
static SCALED_PT MH;					/* 󎚉\̍őc */
static SCALED_PT OX;					/* ̌_̍W */
static SCALED_PT OY;					/* č_̍W */
/* by K.Yoshizawa  Dec. 27, 1992 */
static BOOL HC = FALSE;					/* Z^O */
static BOOL VC = FALSE;					/* Z^O */
static SCALED_PT HS;					/* Z^Öړ */
static SCALED_PT VS;					/* Z^Öړ */
/* by K.Yoshizawa  Dec. 28, 1992 */
static int PF = 1;						/* ʒu */

#define	CFG_PATH	"TEXCFG"
char far *cfg_path = NULL;	/* p_outłQƂ邽߁CGROBALɂD
                                get_configfarmallocĂ*/

char progname[9]     = "dviprt";		/* program name */
char config_name[13];					/* config file name */

/* config file name */
const char *const pk_env_name = "TEXPK";

/* name of the env-variable for pk-font path */
const char *const title_name =
"TeX PRINTER DRIVER "
MACHINE VERSION;
const char *const title_comment =
/*
#ifdef LBP
"("
#  ifdef LIPS3
"LIPSIII"
#   ifdef ESCPAGE
"&"
#   endif
#  endif
#  ifdef ESCPAGE
"ESC/Page"
#  endif
");";

#else
";";
#endif
*/
"";


const char *const title_copyright =
"\nCopyright(C) 1988-89 by TSG, 90-95 by SHIMA,"
#ifdef VFD
"\n\t     1991-95 changed by Akiii, hero.h, hideki, Naochan!, Oh-Yeah?, OkI,"
"\n\t\t     SOLITON, "
#else
"\n\t     1991-95 changed by Akiii, hero.h, Matsuda, Naochan!, Oh-Yeah?, OkI"
"\n\t\t"
#endif
#ifdef	LBP
		"SADA, "
#endif
		"SOLITON, sempa, T.Minagawa, Tomiie, "
#ifndef NOPS
		"T.Uchiyama, "
#endif
		"Yakumo\n\t\tYoshizawa"
#ifdef DOSC
		", HARUYA"
#endif
;

const char *const vfont_config = "dviprt.vfn";

/* vector font config file name */

long view_buf_size = 0x4000L;

char *resume_file;
BOOL f_max_bb;
int org_mag;

#ifndef NOTPIC
int f_tpic_turn_on = 1;	/* default is on */

#ifndef NOPS
extern int f_GS;
extern BOOL f_gbox;
extern BOOL f_gsize;
extern char *gs_exe;
extern char *pbm_path;
#ifdef	GIF
extern BOOL	f_GIF;
#endif
#endif

#endif

#ifdef HIRES98
int hireso = 0;	/* 0: normal, 1: high&interlace, 2: high & noninterlace */
#endif

#if	defined(PC9801) && defined(DOSV)
 #if (__TURBOC__ < 0x452)
 #error Use BC++ 4.02J or later!
 #endif
int	machine = -1; 	  /* 0: PC9801
						 1: DOS/V
						 2: J3100
                       & 1: 16x16 font read */
extern int roms24;
#endif

extern char prt_type;
extern int ff_flg;
extern BOOL f_long_name;
extern BOOL f_font_c;
extern BOOL f_pause;
extern BOOL f_top_margin;
extern BOOL f_resize;
extern int k_scale;
extern int k_base;
extern int f_search;
extern int f_EMS_pages;
extern int total_EMS_page;
extern uint slow_fact;
extern int comp_type;
extern char *goth;
extern char *sub_font;
extern char *fc_name;
extern char *k_dbl;
extern char *k_16;
extern char *f_page_scroll;
extern char *f_out;
extern char *prt_initialize;
extern int f_wait;
extern PIXEL vert_divide;

#ifdef VFD
extern BOOL tatevfd;

#endif

extern BOOL use_lateral_kanji;

/* using lateral Kanji Font for vertical writing (pTeX)
     */
extern BOOL draw_baseline;

/* [for hidden option-1 by Naochan!]
     * draw the baseline.
     */
extern BOOL draw_boxpic;

/* [for hidden option-2 by Naochan!]
     * typesetting with blank boxes (instead of normal characters.)
     */

void set_trans_jis(char *);
void use_romfont(char *);

extern char ptex_mode;

/* when `extended dvi file' encountered, this value is not zero.(pTeX)
     */
#ifndef	NOVFONT
extern int f_use_vfont;
static char *vfont_name;
#  ifdef TTFONT
extern int f_use_ttf;
#  endif
#endif

#if	!defined(PC9801) || defined(DOSV)
extern char *pr_port_str;
#endif

#ifdef LBP
extern int f_use_lfont;
extern int f_vh_ratio;
extern int f_rotate;
extern int f_copy;
extern int d_mincount;
extern char *youshi;
extern int k_base_l;	/* LBP x[Xʒũt@N^[ */
extern int k_scale_l;	/* LBP ␳p̃t@N^[ */
extern int lbp_orig_dpi;	/* LBP{ dpi lftHg300 */
extern LBP_FUNC *lbpf;
extern int f_lbp_comp;
extern int f_font_on_edge;	/* ʂ̉̃tHg */
# ifdef	LIPS3
extern LBP_FUNC lips3_func;

# endif
# ifdef	ESCPAGE
extern LBP_FUNC escpage_func;

# endif
#else
char *youshi;
#endif

#ifdef	FAX
extern char *f_fax;
#endif

#ifdef	FDOWN
#define		MAX_FONTDEF	6
extern int f_download;
extern int f_jdwn;
extern int f_cell;
extern long max_dsize;
extern char *font_def;
#endif

#ifdef	JDWN
extern int dj_min;
extern int dj_skip;
extern int f_gaiji;
#endif

#define	FAR_HEAP	0L
#define BUFFER_NUM	4

BUF_INFO buffers[BUFFER_NUM] =
{
	{NULL,NULL,NULL, DEF_RASTER_SIZE, f_HUGE, -1,0,0,NULL,NULL},
	{NULL,NULL,NULL, DEF_PK_SIZE,     f_HUGE, -1,0,0,NULL,NULL},
	{NULL,NULL,NULL, DEF_BITMAP_SIZE, f_HUGE, -1,0,0,NULL,NULL},
	{NULL,NULL,NULL, DEF_WORK_SIZE,   f_HUGE, -1,0,0,NULL,NULL}
};

FONT_INFO *first_font_info = NULL;
FONT_INFO *font_info_root = NULL;

/*
BUF_INFO *raster_buf_pointer = &buffers[0];
BUF_INFO *pk_buf_pointer = &buffers[1];
BUF_INFO *bitmap_buf_pointer = &buffers[2];
*/

DIMENSION dviout_dimension =
{
	PRINTER_DPI,			/* dpi */
	0,						/* DPI */
	0, 0,					/* device width, height */
	0, 0,					/* output width, height */
	0, 0,					/* buffer width, height */
	0, 0,					/* text width, height */
	DEF_MAG,				/* mag */
	0, 						/* split */
	DEF_PRINT_DIR,			/* print direction */
	0.0,					/* convert parameter */
	0, 0,					/* x-offset, y-offset */
	0, 						/* offset of the page */
	0, 						/* total page */
	0, 0,					/* start page, end page */
	PRT_TYPE,				/* device type */
};

static char *pt_prt_type;

static ARG_TABLE option[] =
{

#ifdef	JAPANESE
	{"mag", INTEGER, (void *)&opt_mag,
	 "mag step(0-9), mag(500-)"},
	{"half", BOOLEAN, (void *)&mag_half,
	 "\x09"   "half)"},
	{"br", LONGINT, (void *)&(buffers[0].size),
	 "WJtHg     obt@TCY(byteP)"},
	{"bf", LONGINT, (void *)&(buffers[1].size),
	 "tHgt@C" AsAbove},
	{"bb", LONGINT, (void *)&(buffers[2].size),
	 "WJrbg}bv" AsAbove},
	{"bw", LONGINT, (void *)&(buffers[3].size),
	 "[Np        " AsAbove},
#ifndef	NEMS
	{"EMS", INTEGER, (void *)&f_EMS_pages,
	 "EMS̎gpy[W(ftHg S)"},
#endif
	{"f", INTEGER, (void *)&test_flg,
	 "\\(0-3)"},
	{"wait", INTEGER, (void *)&f_wait,
	 "G[[0:~ 1:L[͂҂(ftHg) 2-3:]"},
	{"dpi", INTEGER, (void *)&(dviout_dimension.dpi),
	 "dpiݒ"},
	{"DPI", INTEGER, (void *)&(dviout_dimension.DPI),
	 "\03" "(c)"},
	{"e", INTEGER, (void *)&(enlarge),
	 "g嗦(1000{)"},
	{"page", BOOLEAN, (void *)&dvifile_page,
	 "ItZbgy[Ww"},
	{"nf", STRING, (void *)&ff_flg_str,
	 "y[WR[hsgp(܂Ƃ 2)"
#ifdef	LBP
	 "\n\tLBPł́A܂Ƃ̉Ey[W̊Jnʒu"
#endif
	},
	{"o", STRING, (void *)&f_page_scroll,
	 "o̓y[W(r:reverse, e:even, o:odd)"},
	{"V", BOOLEAN, (void *)&(dviout_dimension.print_direction),
	 "90x]"},
	{"X", INTEGER, (void *)&(dviout_dimension.x_offset),
	 "ʒu    (hbgP)"},
	{"Y", INTEGER, (void *)&(dviout_dimension.y_offset),
	 "c" AsAbove},
	{"w", INTEGER, (void *)&add_width,
	 "̕" AsAbove},
	{"h", INTEGER, (void *)&add_height,
	 "c" AsAbove},
	{"W", INTEGER, (void *)&(dviout_dimension.max_width),
	 "p̈󎚉\" AsAbove},
	{"H", INTEGER, (void *)&(dviout_dimension.max_height),
	 "\x0e" "c" AsAbove},
	{"M", BOOLEAN, (void *)&(f_max_bb),
	 "WJrbg}bvp󎚉\TCY"},
	{"T", BOOLEAN, (void *)&f_top_margin,
	 "P[p󂫏C"},
	{"C", BOOLEAN, (void *)&f_center,
	 "Z^O"},
#ifndef NOTPIC
	{"tpic", INTEGER, (void *)&f_tpic_turn_on,
	 "tpic special[0:ignore 1:Bezier(ftHg)"
 #ifndef TPIC_NSPL
	 " 2:spline"
 #endif
	 "]"},
#endif
#ifndef NOPS
	{"GS", INTEGER, (void *)&f_GS,
	"Ghostscript[0:Off 1:On(default) 2:verbose 3:PBM 4:exact PBM 5:gssub]"},
 #ifdef	GIF
	{"GIF", BOOLEAN, (void *)&f_GIF,
	"pbmraw̑gifmonog"},
 #endif
	{"gsx", STRING, (void *)&gs_exe,
	"Ghostscript(ftHg gs.exe)"},
	{"gdat", STRING, (void *)&pbm_path,
	"pbm/gift@C̃fBNg"},
	{"gbox", BOOLEAN, (void *)&f_gbox,
	"荞݉摜̘g\"},
	{"gsize", BOOLEAN, (void *)&f_gsize,
	"\x0c"       "TCY:mag"},
#endif
	{"r", STRING, (void *)&fc_name,
	 "tHgLbṼZ[u"},
	{"L", BOOLEAN, (void *)&f_long_name,
	 "tHg̒ȗ"},
	{"c", BOOLEAN, (void *)&f_font_c,
	 "tHg̐`FbN"},
	{"F", STRING, (void *)&sub_font,
	 "փtHgw"},
	{"A", INTEGER, (void *)&f_search,
	 "tHgT[`͈͊g"},
	{"K", STRING, (void *)&k_dbl,
	 "{pw"},
	{"G", STRING, (void *)&goth,
	 "SVbNw"},
	{"S", INTEGER, (void *)&k_scale,
	 "XP[(1000{) Wl 952"},
	{"g", BOOLEAN, (void *)&use_lateral_kanji,
	 "ptHggp(pTeXc[h)"},
	{"JC", PROCEDURE, (void *)set_trans_jis,
	 "JISR[hϊ"},
	{"romf", PROCEDURE, (void *)use_romfont,
	 "tHggphbg(<max>[:<min>"
#if	defined(J3100)||defined(DOSV)||defined(DOSC)
	"[:<min24>]"
#endif
     "])"},
	{"k", STRING, (void *)&k_16,
	 "-romf= 珜hbg(<dot>:<dot>:...)"},
	{"varf", BOOLEAN, (void *)&f_resize,
	 "tHgXP[uɂ"},
	{"base", BOOLEAN, (void *)&draw_baseline,
	 "x[XC"},
	{"box", BOOLEAN, (void *)&draw_boxpic,
	 "̑ɔőg"},
#ifndef NO_GENFONT
	{"gen", STRING, (void *)&genfont_tmpl,
	 "stHg̎"},
#endif
#ifndef	NOVFONT
	{"vfn", STRING, (void *)&vfont_name,
	 "̋y/JG/aTrueTypetHg"},
 #ifdef TTFONT
	{"ttf", INTEGER, (void *)&f_use_ttf,
	 "TrueTypetHg[0:Off(default) <dot>:Draw sw]"},
 #endif
#endif
#ifndef NO_NTTRPL
	{"nttF", STRING, (void *)&ntt_subst_fonts,
	 "NTTjTeXł̔WatHg̑փtHgw"},
	{"ntt", BOOLEAN, (void *)&ntt_subst,
	 "\x07" "̘atHgAXL[{TeXptHgőp"},
#endif
	{"J", INTEGER, (void *)&k_base,
	 "x[XC(1000{) Wl 0"},
	{"y", PROCEDURE, (void *)&youshi_size,
	 "p̑I [A3|A4|A5|B4|B5|H(t)"
#ifdef LBP
	"|F<width>[:<height>]|T<number>"
#else
    "[l]"
#endif
#ifdef LIPS3
	 "\n\t LIPS3   :[p(pc)|l(p)[0()|1(荷)|2(i)|3(i)]]"
#endif
#ifdef ESCPAGE
"\n\t ESC/Page:[p(pc)|l(p)[1(W)|2(߼݋)[:<ݔԍ>]]]"
#endif
	"]"
	},
#ifdef LBP
	{"lc", INTEGER, (void *)&f_copy,
	 "LBPł̃Rs["},
#endif
#ifdef VFD
	{"RV", BOOLEAN, (void *)&tatevfd,
	 "vfdtHg̉]"},
#endif
#ifndef	NOTATEGAKI
	{"R", BOOLEAN, (void *)&tategaki,
 #ifdef	LBP
	 "LBP, "
 #endif
	 "̋ỹtHg90x]"},
#endif
	{"O", STRING, (void *)&f_out,
	 "o̓t@C(!!!͕Ŕԍ)"},
	{"s", INTEGER, (void *)&slow_fact,
	 "x(0,...,10000)"},
	{"Z", BOOLEAN, (void *)&f_pause,
	 "PŖɈU~"},
	{"I", STRING, (void *)&prt_initialize,
	 "v^R[hLqt@C\n"},

	/* by K.Yoshizawa  Dec. 26, 1992 */
	{"newsize", BOOLEAN, (void*)&f_use_new_size_option,
	 "ȉ̃TCYEIvVgp"},
	{"PW", LENGTH, (void*)&PW,
	"p̉ [ftHg 210mm(A4)]"},
	{"PH", LENGTH, (void*)&PH,
	"\x06" "c [ftHg 297" AsAbove},
	{"TM", LENGTH, (void*)&TM, "\x04" "[̈󎚕s\̕"},
	{"BM", LENGTH, (void*)&BM, "\x04" "" AsAbove},
	{"LM", LENGTH, (void*)&LM, "\x04" "" AsAbove},
	{"RM", LENGTH, (void*)&RM, "\x04" "E" AsAbove},
	{"MW", LENGTH, (void*)&MW, "󎚉\̍ő剡"},
	{"MH", LENGTH, (void*)&MH, "\x10"          "c" AsAbove},
	{"OX", LENGTH, (void*)&OX, "̈ړ"},
	{"OY", LENGTH, (void*)&OY, "c" AsAbove},

	/* by K.Yoshizawa  Dec. 27, 1992 */
	{"HC", BOOLEAN, (void*)&HC, "Z^O"},
	{"VC", BOOLEAN, (void*)&VC, "" AsAbove},
	{"HS", LENGTH, (void*)&HS,  "Z^Öړ"},
	{"VS", LENGTH, (void*)&VS,  "" AsAbove},
	/* by K.Yoshizawa  Dec. 28, 1992 */
	{"PF", INTEGER, (void*)&PF, "ʒu [1:[(ftHg) 2:]\n"},
	{"=", PROCEDURE, (void *)opt_cfg, "p[^t@Cw"},
#ifdef FAX
	{"FAX", STRING, (void *)&f_fax, "G3 FAX`"},
#endif
	{"comp", INTEGER, (void *)&comp_type,
	 "f[^k[0: 1:PCL mode 1 2:PCL mode 2]"},
	{"p", STRING, (void *)&pt_prt_type,
	 "v^̎ e:ESC/P p:PC-PR n:NM o:other(default prtctl.cfg)"
#ifdef LBP
	 "\n\t"
 #ifdef LIPS3
	 "l:LIPS3 "
 #endif
 #ifdef ESCPAGE
	 "m:ESC/Page "
 #endif
	 "[v:̏c k:aO d:download_size r:real_size"
	 "\n\tm:minimal_count f:font_def D:dpi j:baseline s:size_adj E:edge"
	 "\n\tu:minimal_unit c:compress o:other"
#endif
	},

#if	!defined(PC9801) || defined(DOSV)	/* J-3100,AX,DOS/V */
	{"P", STRING, (void *)&pr_port_str,
	 "v^|[g̎w, 0 for BIOS(default), [B]1`[B]4 for LPT1:`LPT4:"},
#endif
#if	defined(PC9801) && defined(DOSV)
	{"hard", INTEGER, (void *)&machine,
	 "@[0:PC9801 1:DOS/V"
 #if defined(J3100)
	 " 2:J3100"
 #endif
	 "]"},
#endif

#else
	{"mag", INTEGER, (void *)&opt_mag,
	 "mag step(0-9), mag(500-)"},
	{"half", BOOLEAN, (void *)&mag_half,
	 "\x09"  "half)"},
	{"br", LONGINT, (void *)&(buffers[0].size),
	 "raster buffer size"},
	{"bf", LONGINT, (void *)&(buffers[1].size),
	 "font  " AsAbove},
	{"bb", LONGINT, (void *)&(buffers[2].size),
	 "bitmap" AsAbove},
	{"bw", LONGINT, (void *)&(buffers[3].size),
	 "work  " AsAbove},
#ifndef	NEMS
	{"EMS", INTEGER, (void *)&f_EMS_pages,
	 "number of pages to use EMS(default all)"},
#endif
	{"f", INTEGER, (void *)&test_flg,
	 "test-flag(0-3)"},
	{"wait", INTEGER, (void *)&f_wait,
	 "when error occurs, 0:Stop 1:wait key_input(default) 2-3:ignore"},
	{"dpi", INTEGER, (void *)&(dviout_dimension.dpi),
	 "horizontal dpi"},
	{"DPI", INTEGER, (void *)&(dviout_dimension.DPI),
	 "vertical  " AsAbove},
	{"e", INTEGER, (void *)&(enlarge),
	 "enlarge*1000"},
	{"page", BOOLEAN, (void *)&dvifile_page,
	 "pages are dvifile-pages"},
	{"nf", STRING, (void *)&ff_flg_str,
	 "No use of form feed code"},
	{"o", STRING, (void *)&f_page_scroll,
	 "output (r:reverse, e:even pages, o:odd pages)"},
	{"V", BOOLEAN, (void *)&(dviout_dimension.print_direction),
	 "vertical-output"},
	{"X", INTEGER, (void *)&(dviout_dimension.x_offset),
	 "x-offset     (pixel)"},
	{"Y", INTEGER, (void *)&(dviout_dimension.y_offset),
	 "y" AsAbove},
	{"w", INTEGER, (void *)&add_width,
	 "add width" AsAbove},
	{"h", INTEGER, (void *)&add_height,
	 "\x04" "length" AsAbove},
	{"W", INTEGER, (void *)&(dviout_dimension.max_width),
	 "device width" AsAbove},
	{"H", INTEGER, (void *)&(dviout_dimension.max_height),
	 "\x07" "height" AsAbove},
	{"M", BOOLEAN, (void *)&(f_max_bb),
	 "use device size for bit map buffer"},
	{"T", BOOLEAN, (void *)&f_top_margin,
	 "correct Top margin for cut sheets"},
	{"C", BOOLEAN, (void *)&f_center,
	 "Centering"},
#ifndef NOTPIC
	{"tpic", INTEGER, (void *)&f_tpic_turn_on,
	 "tpic special(0:ignore 1:Bezier(default)"
 #ifndef TPIC_NSPL
	 " 2:spline"
 #endif
	 "]"},
#endif
#ifndef NOPS
	{"GS", INTEGER, (void *)&f_GS,
	"Ghostscript[0:Off 1:On(default) 2:verbose 3:PBM 4:exact PBM 5:gssub]"},
# ifdef	GIF
	{"GIF", BOOLEAN, (void *)&f_GIF,
	"use gifmono in place of pbmraw"},
# endif
	{"gsx", STRING, (void *)&gs_exe,
	"Ghostscript(default gs.exe)"},
	{"gdat", STRING, (void *)&pbm_path,
	"Directory of pbm/gif file"},
	{"gbox", BOOLEAN, (void *)&f_gbox,
	"draw frame for picture"},
	{"gsize", BOOLEAN, (void *)&f_gsize,
	 "picture size:include mag"},
#endif
	{"r", STRING, (void *)&fc_name,
	 "Save Font"},
	{"L", BOOLEAN, (void *)&f_long_name,
	 "cut center of long font names"},
	{"c", BOOLEAN, (void *)&f_font_c,
	 "Check font matching"},
	{"F", STRING, (void *)&sub_font,
	 "Font substitute"},
	{"A", INTEGER, (void *)&f_search,
	 "\x05" "search"},
	{"K", STRING, (void *)&k_dbl,
	 "Double size Kanji"},
	{"G", STRING, (void *)&goth,
	 "Gothic"},
	{"g", BOOLEAN, (void *)&use_lateral_kanji,
	 "Use Lateral Kanji Font in pTeX `tate' mode"},
	{"JC", PROCEDURE, (void *)set_trans_jis,
	 "translate JIS code"},
	{"romf", PROCEDURE, (void *)use_romfont,
	 "dots of using Kanji ROM Font(<max>[:<min>"
#if	defined(J3100)||defined(DOSV)||defined(DOSC)
	"[:<min24>]"
#endif
	 "])"},
	{"k", STRING, (void *)&k_16,
	 "\x05" "not using Kanji ROM Font(<dot>:<dot>:...)"},
	{"varf", BOOLEAN, (void *)&f_resize,
	 "resize all fonts"},
	{"base", BOOLEAN, (void *)&draw_baseline,
	 "draw the baseline"},
	{"box", BOOLEAN, (void *)&draw_boxpic,
	 "typeset by boxes instead of characters"},
#ifndef NO_GENFONT
	{"gen", STRING, (void *)&genfont_tmpl,
	 "automatic font generation"},
#endif
	{"vfn", STRING, (void *)&vfont_name,
	 "Syotai Club's/JG/Kanji TrueType Font"},
#  ifdef TTFONT
	{"ttf", INTEGER, (void *)&f_use_ttf,
	 "TrueType Font[0:Off(default) <dot>:Draw sw]"},
#  endif
#ifndef NO_NTTRPL
	{"nttF", STRING, (void *)&ntt_subst_fonts,
	 "NTTjTeX Nonstandard Font substitute"},
	{"ntt", BOOLEAN, (void *)&ntt_subst,
	 "\x08" "Font substitute"},
#endif
	{"S", INTEGER, (void *)&k_scale,
	 "Kanji scale*1000 (default 952)"},
	{"J", INTEGER, (void *)&k_base,
	 "\x06" "base line*1000 (default 0)"},
	{"y", PROCEDURE, (void *)&youshi_size,
	 "Paper select [A3|A4|A5|B4|B5|H"
#ifdef LBP
	"|F<width>[:<height>]|T<number>"
#else
    "[l]"
#endif
#ifdef LIPS3
	 "\n\tLIPS3   :[p(port.)|l(land.)[<0(auto)|1(manual)|2(upper)|3(lower)>]]"
#endif
#ifdef ESCPAGE
	 "\n\tESC/Page:[p(port.)|l(land.)[1(normal)|2(option)[:bin]]]"
#endif
	 "]"
	},
#ifdef LBP
	{"lc", INTEGER, (void *)&f_copy,
	 "Number of copy by LBP"},
#endif
#ifdef VFD
	{"RV", BOOLEAN, (void *)&tatevfd,
	 "Rotate vfd font"},
#endif
#ifndef	NOTATEGAKI
	{"R", BOOLEAN, (void *)&tategaki,
	 "Font rotational printing with "
#ifdef	LBP
	 "LBP/"
#endif
	 "Zeit font"},
#endif
	{"O", STRING, (void *)&f_out,
	 "File output(!!! is replaced by page)"},
	{"s", INTEGER, (void *)&slow_fact,
	 "slow speed(0,...,10000)"},
	{"Z", BOOLEAN, (void *)&f_pause,
	 "Pause for every page"},
	{"I", STRING, (void *)&prt_initialize,
	 "File with code intializing printer"},

	/* by K.Yoshizawa  Dec. 26, 1992 */
	{"newsize", BOOLEAN, (void*)&f_use_new_size_option,
	 "use the following size option"},
	{"PW", LENGTH, (void*)&PW,
	"paper width  [default 210mm(A4)]"},
	{"PH", LENGTH, (void*)&PH,
	"paper height [default 297mm(A4)]"},
	{"TM", LENGTH, (void*)&TM, "top    mechanical gap"},
	{"BM", LENGTH, (void*)&BM, "bottom" AsAbove},
	{"LM", LENGTH, (void*)&LM, "left  " AsAbove},
	{"RM", LENGTH, (void*)&RM, "right " AsAbove},
	{"MW", LENGTH, (void*)&MW, "max printable width"},
	{"MH", LENGTH, (void*)&MH, "\x0e"        "height"},
	{"OX", LENGTH, (void*)&OX, "horizontal move"},
	{"OY", LENGTH, (void*)&OY, "vertical  " AsAbove},
	/* by K.Yoshizawa  Dec. 27, 1992 */
	{"HC", BOOLEAN, (void*)&HC, "horizontal centering"},
	{"VC", BOOLEAN, (void*)&VC, "vertical  " AsAbove},
	{"HS", LENGTH, (void*)&HS, "horizontal shift after centering"},
	{"VS", LENGTH, (void*)&VS, "vertical  " AsAbove},
	/* by K.Yoshizawa  Dec. 28, 1992 */
	{"PF", INTEGER, (void*)&PF, 
		"paper feed position [1:left(default) 2:center]\n"},

	{"=", PROCEDURE, (void *)opt_cfg, "parameter file"},

#ifdef FAX
	{"FAX", STRING, (void *)&f_fax, "G3 FAX"},
#endif
	{"p", STRING, (void *)&pt_prt_type,
	 "type of printer e:ESC/P p:PC-PR n:NM o:other(default prtctl.cfg)"
#ifdef LBP
	 "\n\t"
#  ifdef LIPS3
	 "l:LIPS3 "
#  endif
#  ifdef ESCPAGE
	 "m:ESC/Page "
#  endif
	 "[v:font_aspect k:gaiji d:download_size r:real_size"
	 "\n\tm:minimal_count f:font_def D:dpi j:baseline s:size_adj E:edge"
	 "\n\tu:minimal_unit c:compress o:other"
#endif
	},

#if !defined(PC9801) || defined(DOSV)	/* J-3100,AX,DOS/V */
	{"P", STRING, (void *)&pr_port_str,
	 "Use Printer Port Directly, 0,[B]1,..,[B]4 for BIOS,[BIOS]LPT1,..."},
#endif
	{"comp", INTEGER, (void *)&comp_type,
	"Compress data[0:no compression 1:PCL mode 1 2:PCL mode 2]"},
#if	defined(PC9801) && defined(DOSV)
	{"hard", INTEGER, (void *)&machine,
	 "Hardware[0:PC9801 1:DOS/V"
 #if defined(J3100)
	 " 2:J3100"
 #endif
	 "]"},
#endif

#endif	/* defined(JAPAMESE) */
	{NULL}
};


#if	defined(PC9801) && defined(DOSV)
int check_pc(void)
{
	int	pos;
	union REGS regs;
	static	char far *cslx = (char far*)0x060011cL;

	pos = *cslx;			/* check if PC-9801 */
	putc( ' ', stderr );
	if( *cslx != pos+1 ) goto no_pc98;
	putc( ' ', stderr );
	if( *cslx != pos+2 ) goto no_pc98;
	putc( '\x08', stderr );
	if( *cslx != pos+1 ) goto no_pc98;
	putc( '\x08', stderr );
	if( *cslx == pos )
		return (M_PC98);		/* PC-9801 */
no_pc98:
#ifdef	J3100
	regs.x.ax = 0x4900;
	int86(0x15, &regs, &regs);
	if(regs.x.cflag || regs.h.bl){	/* JDOS_or_PCDOS	*/

		asm {
			push ds
			mov  ax,4900h
			int  15h
			xor  ax,ax
			mov  ds,ax
			mov  ax,ds:[7dh*4]
			mov  ax,ds:[7dh*4+2]
			mov  dl,1
			pop  ds
		}
		if(_AX == 0){				/* not IBM JDOS				*/
			regs.h.ah = 0x30;			/* get OEM No */
			intdos(&regs, &regs);
			if(regs.h.bh == 0x29)
				return (M_J31);			/* J-3100 */
		}
	}
#endif
	return(M_DOSV);
}
#endif

void get_config(int argc, char **argv)
{
	int i, l;
	char real_name[MAXPATH], v_real_name[MAXPATH];
	char path_name[MAXPATH];
	char *cfgpath, *srcpath;

	ENTER("get_config");

	fnsplit(argv[0], real_name, v_real_name, config_name, path_name);
	if (memcmp(strlwr(config_name), "dvi", 3) == 0)
		strcpy(progname, config_name);
	strcpy(config_name, progname);
	strcat(config_name, ".par");
	if (argc <= 1){
#if defined(PC9801) && defined(DOSV)
		machine = check_pc();
#endif
		return;
	}

	if ((cfgpath = getenv(CFG_PATH)) != NULL) {
		strncpy(path_name, cfgpath, MAXPATH - 2);
		i = strlen(path_name);
		if (isalnum(path_name[i - 1])) {
			path_name[i] = '\\';
			path_name[++i] = '\0';
		}
		cfg_path = (char far *)farmalloc((long)i + 2L);

		/* p_out.cŎĝŃRs[ : strcpy(cfg_path, path_name); Ɠ */
		{
			char *spt;
			char far *dpt;

			for (spt = path_name, dpt = cfg_path; (*dpt++ = *spt++) != 0;);
		}
	}
	else {
		cfg_path = (char far *)"";
		path_name[0] = '\0';
	}
	strcpy(real_name, path_name);
	strcat(real_name, config_name);

	if (access(real_name, 0) == -1){
		if ((srcpath = searchpath(config_name)) != NULL)
			strncpy(real_name, srcpath, MAXPATH - 2);
		else *real_name = 0;
	}
	if (*real_name) set_config(option, real_name);
	set_option(option, argc, argv);
#if	defined(PC9801) && defined(DOSV)
	if(machine == -1)
		machine = check_pc();
	else if(machine < 0 || 
 #ifdef J3100
	  machine > M_J31)
 #else
	  machine > M_DOSV)
 #endif
		error(ILLEGAL_ARGS, "-hard=%d", machine);
	if(machine!=M_PC98){
		pk_buf_pointer->size = 0xffffL;
		if(roms24 < 0){
 #ifdef	J3100
		roms24 = (machine == M_J31)?20:10000;
 #else
		roms24 = 10000;
 #endif
		}
		goto sk1;
	}
#endif
#ifdef HIRES98
	/* PC9801 nC][V[h̔ */
	hireso = 0;					/* ftHg̓m[}[h */
	if ((*(char far *)(0x00000501)) & 8) {
		/* VXeʈ 0h:459h  rbg 3 ŃC^[[X[h̒ */
		hireso = ((*(char far *)(0x00000459)) & 8) ? 2 : 1;
		pk_buf_pointer->size = 0xffffL;
	}
	/* [h\ */
#ifdef	DEBUG1
	switch (hireso) {
		  case 0:
			  fprintf(stderr, "\nNormal Mode\n");
			  break;
		  case 1:
			  fprintf(stderr, "\nHighReso. & Interlace\n");
			  break;
		  case 2:
			  fprintf(stderr, "\nHighReso. & Non-Interlace\n");
			  break;
	}
#endif
#endif
sk1:
#ifndef	NOVFONT
	if (vfont_name != NULL && *vfont_name != '-') {
		f_use_vfont = TRUE;
		make_path(real_name,
			NULL,
			(*vfont_name == 0 || *vfont_name == '+')?"dviprt":vfont_name,
			".vfn");
		make_path(v_real_name, path_name, real_name, NULL);
		if (access(v_real_name, 0) == -1) {
			if ((srcpath = searchpath(real_name)) != NULL)
				strncpy(v_real_name, srcpath, MAXPATH - 2);
		}
		if (0 != (l = get_vfont_name(v_real_name))) {
			if (l > 0)
				error(WARNING,
					"[vfont] dviout.vfn/dviprt.vfn error(line:%d)", l);
			else
				error(WARNING,
					"[vfont] Can't open dviout.vfn/dviprt.vfn file");
			exit(-1);
		}
	}
#endif
	END();
}

void initialize(DVIFILE_INFO *dvi, DIMENSION *dim)
{
#ifndef NEMS
	int i, j;
#endif

	ENTER("initialize");
	read_post(dvi);
	set_prt_type(dim);
	set_dimension(dvi, dim);
	make_font_list(dvi, dim);
	make_page_index(dvi, dim);
	pixel_init(dvi, dim);
	buffer_init();
	stack_init(dvi->stack_depth);
	decode_init();

#ifndef NOTPIC
	if (f_tpic_turn_on)
		tpic_init(dim->buf_height);
	/* alloc y-bucket[vmax] and activate tpic interpretation */
#endif
#ifndef NEMS
	for (i = 0; system_ems[++i] != -1; ){
		if ((j = system_ems[i]) > 0){
			system_ems[i] = system_EMS_end;
			system_EMS_end += j;
			max_user_page -= j;
		}
		else system_ems[i] = -1;
	}
#endif

	END();
}

/* set youshi size */
static void youshi_size(char *opt)
{
	int	ch;

	ch = opt[1];
	youshi = (char*)dup_string(opt);
	switch(toupper(*opt)){
		case 'A':
			if (ch == '4'){
				PW = MM_TO_SP(210);
				PH = MM_TO_SP(297);
			}
		    else if (ch == '3'){
				PW = MM_TO_SP(297);
				PH = MM_TO_SP(420);
			}
			else if (ch == '5'){
				PW = MM_TO_SP(148.5);
				PH = MM_TO_SP(210);
			}
			goto skip_number;
		case 'B':
			if (ch == '4'){
				PW = MM_TO_SP(257);
				PH = MM_TO_SP(364);
			}
			else if (ch == '5'){
				PW = MM_TO_SP(182);
				PH = MM_TO_SP(257);
			}
			goto skip_number;
		case 'H':
			PW = MM_TO_SP(100);
			PH = MM_TO_SP(148);
			goto skip_number;
		case 'F':
			while (isdigit(*++opt));
			if (*opt != ':' && *opt !=';') break;
		case 'T':
skip_number:
			while (isdigit(*++opt));
			break;
		default:
			error(ILLEGAL_ARGS, opt);
			break;
	}
	switch(toupper(*opt)){
		case 'P':
			dviout_dimension.print_direction = HORIZONTAL;
			break;
		case 'L':
			dviout_dimension.print_direction = VERTICAL;
			break;
	}
}

static void set_prt_type(DIMENSION *dim)
{
	int ch;
	char *pt;
	SCALED_PT len;
#ifdef LBP
	int num;
	int lbp_shift = 0;

	f_lbp_prt = FALSE;
#endif
	len = 0;
#ifdef	FAX
	if (f_fax != NULL){
		vert_divide = 8;
		dim->prt_type = FAXFORM;
		if (pt_prt_type == NULL){
			if (dim->dpi == 0)
				dim->dpi = 200;
			goto escp1;
		}
	}
#endif
	if (pt_prt_type == NULL) goto escp;
	switch (*pt_prt_type | 0x20) {
escp:	case (T_ESC_P):
			dim->prt_type = ESC_P;
escp1:		if (dim->dpi == 0)
				dim->dpi = 180;
			break;

		case (T_PC_PR):
			dim->prt_type = PC_PR;
			if (dim->dpi == 0)
				dim->dpi = 160;
			break;

		case (T_PC_NM):
			dim->prt_type = PC_NM;
			goto escp1;

#ifdef	LIPS3
		case (T_LBP_LIPS3):
			dim->prt_type = LBP_LIPS3;
			lbpf = &lips3_func;
			f_lbp_prt = TRUE;
			len = MM_TO_SP(5);
			break;
#endif
#ifdef	ESCPAGE
		case (T_LBP_ESCPAGE):
			dim->prt_type = LBP_ESCPAGE;
			lbpf = &escpage_func;
			f_lbp_prt = TRUE;
			len = IN_TO_SP(0.2);
			break;
#endif
		case (T_PR_OTHER):
			dim->prt_type = PR_OTHER;
			get_prt_ctl(pt_prt_type + 1);
			if (dim->dpi == 0) {
				fprintf(stderr, "Warning : Assume Printer DPI = 180\n\n");
				dim->dpi = 180;
			}
			break;

		default:
			error(ILLEGAL_ARGS, "-p=%s", pt_prt_type);
			break;
	}
	if (TM < 0){
#ifdef	LBP
		lbp_shift |= 1;
#endif
		TM = len;
	}
	if (RM < 0){
#ifdef	LBP
		lbp_shift |= 2;
#endif
		RM = len;
	}
	if (BM < 0) BM = len;
	if (LM < 0) LM = len;

#ifdef LBP
	if (f_lbp_prt) {
		char *p;
		char *ext_cfg = NULL;
			/* default  minimal_unit, vertical_unit ɑ΂{ */
		int hunit = 1, vunit = 1;

		f_use_lfont = TRUE;
		f_download = 1;
		if( *(pt = pt_prt_type + 1) && *pt < 0x40 ) pt++;
		while ((ch = *pt++) != 0) {
			num = atoi(pt);
			switch (ch) {
			  case 'v':
				  f_vh_ratio = num;
				  if (f_vh_ratio == 0)
					  f_use_lfont = FALSE;
				  break;
			  case 'd':
#ifdef	FDOWN
				  max_dsize = 0x400L * num;
				  if (max_dsize <= 0)
					  f_download = 0;
#endif
				  break;
			  case 'r':
				  f_cell = 1;
				  break;
			  case 'j':
				  k_base_l = num;
				  break;
			  case 's':
				  k_scale_l = num;
				  break;
			  case 'D':
				  lbp_orig_dpi = num;
				  break;
			  case 'o':
			      ext_cfg=pt;
				  break;
			  case 'm':
				  d_mincount = num;
				  break;
			  case 'f':
				  if (font_def == NULL)
					  font_def = pt - 1;
				  break;
#ifdef	JDWN
			  case 'g':
				  f_gaiji = f_jdwn = 1;
				  break;
			  case 'k':
				  if(!tategaki){
					  f_jdwn = 1;
#ifndef NEMS
					  system_ems[1] = 1;
#endif
					  if(isdigit(*pt))
						  dj_min = 127 - num;
					  while(isdigit(*pt)) pt++;
					  if(*pt && isdigit(pt[1]))
					  dj_skip = atoi(++pt);
				  }
				  break;
#endif
			  case 'c':
				  f_lbp_comp = 1;
				  break;
			  case 'u':
				  /* minimal_unit  vertical_unit  option ɂύX */
				  /* horizontal_unit  num, vertical  8 bit. */
				  if (num > 0) hunit = num;	
				  /* horizontal_unit  -num, vertical  24 bit. */
				  if (num < 0){
					  hunit = -num;
					  vunit = 3;
				  }
				  break;
			  case 'E':
				  /* LIPSŎʂ̉ɂƎvtHgVDň󎚂
				     ƂB*/
				  f_font_on_edge=TRUE;
				  break;
			}
			while (*pt != ';' && *pt != ':' && *pt)
				pt++;
			if (*pt)
				pt++;
		}
		/* LBP v^R[h̏EύX */
		/* ܂ `u' l default Zbg */
		set_LBP_prt_ctl(hunit, vunit);
		/* `o' w肳Ă΁AꂪDɂȂB */
		if (ext_cfg)
			get_prt_ctl(ext_cfg);

		if (f_vh_ratio < 200 || f_vh_ratio > 5000)
			f_vh_ratio = 1000;
		if (dim->dpi == 0)
			dim->dpi = (lbp_orig_dpi == 0)?300:lbp_orig_dpi;

		if (ff_flg_str != NULL){
#ifndef NNSZ
			length_to_dot(ff_flg_str, &ff_flg, 0);
#else
			ff_flg = atoi(ff_flg_str);
#endif
		}
		if (dim->print_direction == HORIZONTAL){
			if (dviout_dimension.max_width == 0)
				dviout_dimension.max_width = 2360;
			if (dviout_dimension.max_height == 0)
				dviout_dimension.max_height = 3387;
			goto def_tm0;
		}else{
			dim->print_direction = HORIZONTAL;
			f_rotate = TRUE;
			if (f_use_new_size_option){
				len = PH; PH = PW; PW = len;
				len = TM; TM = RM; RM = BM; BM = LM; LM = len;
				len = MH; MH = MW; MW = len;
				if (lbp_shift & 2) goto def_tm;
			}
			else{
def_tm0:		if(lbp_shift & 1){
def_tm:
#ifdef	ESCPAGE
					if (dim->prt_type == LBP_ESCPAGE) TM = IN_TO_SP(0.2);
					else
#endif
		                              				  TM = MM_TO_SP(10.33);
				}
			}
			if (dviout_dimension.max_width == 0)
				dviout_dimension.max_width = 3387;
			if (dviout_dimension.max_height == 0)
				dviout_dimension.max_height = 2360;
		}
	}
	else
#endif /*LBP*/
		if (ff_flg_str != NULL){
			switch(*ff_flg_str){
				case '+':
						ff_flg = 1;
						break;
				case '2':
						ff_flg = 0;
		}
	}
	if (dim->DPI == 0)
		dim->DPI = dim->dpi;
	if (dviout_dimension.max_width == 0)
		dviout_dimension.max_width = 8 * dim->dpi;
	if (dviout_dimension.max_height == 0)
		dviout_dimension.max_height = 11 * dim->DPI;
#ifdef	FDOWN
	if (f_download)
		fc_name = NULL;
#endif
}

/* optional parameter file */
static void opt_cfg(char *opt)
{
	set_config(option, opt);
}

void help_out(void)
{
	ENTER("help_out");

	printf("usage : %s [option(s)] dvifile [page(s) eg. -4 7 . 9 12-14 20- @file]\n\n", progname);

#ifdef	JAPANESE
	option_usage(option);
	printf("\nLIvV́A parameter file <%s> Ŏw\\ \n", config_name);
#else
	printf("options are as follows :\n");
	option_usage(option);
	printf("\noptions can be directed in %s\n", config_name);
#endif
	EXIT(0);
}

#define CM_INCH 2.54
/* cm per inch */

static int pres;
static void set_dimension(DVIFILE_INFO *dvi, DIMENSION *dim)
	/* size_para, magnification, text_width, height ̐ݒD
     */
{
	static int true_mag[] =
	{1000, 1200, 1440, 1728, 2074, 2488, 2986, 3583, 4300, 5160};
#ifndef	USE_FLOAT
	ulong num1, num2;
	long num3;
	int q;
#endif

	ENTER("set_text_size");

	dim->mag = (int)dvi->mag;

	if (mag_half)
		dim->mag = 1095;		/* magstep half */
	else {
		if (opt_mag != -1)
			if (opt_mag >= 0 && opt_mag <= 9)
				dim->mag = true_mag[opt_mag];
			else if(opt_mag >= 500)
				dim->mag = opt_mag;
			else
				error(ILLEGAL_ARGS, "mag step over");
	}

	dim->total_page = dvi->total_page;

	if (dim->dpi <= 0)
		error(ILLEGAL_ARGS, "dpi");
#ifdef	NOFLOAT
	num1 = mult_long((ulong)dvi->den, 254000000L);
	q = pres;

	num2 = mult_long((ulong)dvi->num, (ulong)dim->dpi);
	q -= pres;
	num2 = mult_long(num2, (ulong)dim->mag);
	q -= pres;

	num3 = 0;
	while (num1 >= num2) {
		num1 -= num2;
		num3++;
	}
	while (q-- >= 0) {
		num3 += num3;
		if ((num1 += num1) >= num2) {
			num1 -= num2;
			num3++;
		}
	}
	num3 >>= 1;
	if ((num3 & 1) != 0)
		num3++;
	if (enlarge != 0) {
		if (enlarge < 300 || enlarge > 4000)
			error(ILLEGAL_ARGS, "-e should be 300-4000");
		else {
			num3 = num3 * 1000 / enlarge;
		}
	}
	dim->size_para = num3;
#else
	dim->size_para = ((double)dvi->num * (double)dim->dpi * (double)dim->mag) /
		((double)dvi->den * CM_INCH * 100000000.0);
#endif
	set_convert(dim->size_para, dim->dpi, dim->DPI);
	/* set pixel<==>scaled-pt parameter */

	if ((dim->text_width = sptopixel(dvi->u)) == 0)
		f_max_bb = TRUE;
	dim->text_height = vtopixel(dvi->l + HEADER_DEPTH + FOOTER_DEPTH);

	if (f_center == TRUE) {
		if (dim->print_direction == HORIZONTAL) {
			if (dim->max_width > 0) {
				dim->x_offset += (dim->max_width - dim->text_width) / 2;
			}
			if (dim->max_height > 0) {
				dim->y_offset += (dim->max_height - dim->text_height) / 2;
			}
		}
		else {
			if (dim->max_width > 0) {
				dim->x_offset += (dim->max_width - dim->text_height) / 2;
			}
			if (dim->max_height > 0) {
				dim->y_offset += (dim->max_height - dim->text_width) / 2;
			}
		}
	}
	END();
}

#ifdef	NOFLOAT
static ulong mult_long(ulong num1, ulong num2)
{
	int i;

	if (num1 == 0 || num2 == 0) {
		pres = 0;
		return (0L);
	}
	i = 0;
	while (num1 >= 0x2000000L) {
		i++;
		num1 >>= 1;
	}
	while (num1 < 0x1000000L) {
		i--;
		num1 += num1;
	}
	while (num2 >= 0x2000000L) {
		i++;
		num2 >>= 1;
	}
	while (num2 < 0x1000000L) {
		i--;
		num2 += num2;
	}
	pres = i + 20;
	return (mult20(num1, num2));
}
#endif

#define	END_DVI	223
#define ID 2
#define ID_PTEX 3
/* id number for searching for postamble
     */

static void read_post(DVIFILE_INFO *dvi)
	/* POSTAMBLẼf[^ǂݏoD
     */
{
	long endofs;
	int code;

	ENTER("read_post");

	if ((uchar)read_byte(dvi->file_ptr) != PRE ||
		(uchar)read_byte(dvi->file_ptr) != ID) {
		error(FILE_FAULT, "Not DVI file");
	}
	for (endofs = -3L; fseek(dvi->file_ptr, endofs, SEEK_END),
		 (code = (uchar)read_byte(dvi->file_ptr)) != ID; endofs--)
		/* Search id number
             */
		if (code == ID_PTEX) {
#ifdef	DEBUG1
			printf("Extended DVI file encountered. Turn on pTeX mode.\n");
#endif
			ptex_mode++;
			break;
		}
		else if (code == EOF || code != END_DVI)
			error(FILE_FAULT, "No ID");

	fseek(dvi->file_ptr, endofs - 4L, SEEK_END);
	if ((dvi->post = read_long(dvi->file_ptr)) <= 0)
		error(COMMAND_ERROR, "Negative Pointer(POST)");
	/* Read the position of POSTAMBLE */

	fseek(dvi->file_ptr, dvi->post, SEEK_SET);
	/* Set file-ptr at POSTAMBLE */

	if ((uchar)read_byte(dvi->file_ptr) != POST)
		error(COMMAND_ERROR, "No Postamble");

	if ((dvi->last_bop = read_long(dvi->file_ptr)) <= 0)
		error(COMMAND_ERROR, "Negative Pointer(Last BOP)");

	dvi->num = read_long(dvi->file_ptr);
	dvi->den = read_long(dvi->file_ptr);
	org_mag = dvi->mag = read_long(dvi->file_ptr);

	dvi->l = (SCALED_PT)read_long(dvi->file_ptr);
	dvi->u = (SCALED_PT)read_long(dvi->file_ptr);

	dvi->stack_depth = read_int(dvi->file_ptr);
	dvi->total_page = read_int(dvi->file_ptr);

	if (dvi->num <= 0 || dvi->den <= 0 || dvi->mag <= 0)
		error(COMMAND_ERROR, "Reading Illegal Long");

	if (dvi->stack_depth < 0 || dvi->total_page <= 0)
		error(COMMAND_ERROR, "Reading Illegal Integer");

	END();
}

static void calc_new_size_option(DVIFILE_INFO *dvi, DIMENSION *dim)
	/* Added by K.Yoshizawa  Dec. 26, 1992
	 * Modified by K.Yoshizawa  Dec. 31, 1992
	 */
{
	SCALED_PT w, h, LS;

/* XebvPFʒuɂ␳ */

	/* FLS (v^̈󎚉\̍[p̍[܂ł̋)̈
	 *
	 * {ł΁ALS [łȂꍇ́Aes̃rbgC[Wv^
	 * oOɁA LS hbgɕϊAv^̃wbh
	 * EɈړĂ΂悢͂łB
	 *
	 * Av^ɂẮAꂪƂƂȂ̂ŁArbg}b
	 * vEobt@̕ LS LƂ邱ƂŁAΏĂBȃ
	 * ϓ_͍D܂ȂAbI[uƂāAĂB
	 */

	LS = 0;
	switch(PF) {
	case 1: /* [ */
		break;
	case 2: /*  */
		if(MW > 0) {		/* 󎚉\ő啝̎w肠鎞̂݁AvZ */
			if (PW <= MW) {	/* p̕Fꂪ */
				LS = (MW - PW) / 2;
			} else {		/* 󎚉\ő啝̕ */
				/* EɋϓɃ}[Ww肳ꂽ̂Ƃ݂ȂAƂ
				 * [ƂĈ */
				LM += (PW - MW) / 2;
				RM += (PW - MW) / 2;
			}
		}
		break;
	default:
		error(ILLEGAL_ARGS
#ifdef	JAPANESE
		, "-PF ̒lُ"
#else
		, "-PF option value"
#endif
		, (long)PF);
		break;
	}

/* XebvQFp̃TCYA̗pł̈󎚉\̈vZ */

	w = PW - LM - RM; 	/* w ̗͂pň󎚂ׂő啝̎bl */
	h = PH - TM - BM;	/* h ̗͂pň󎚂ׂő咷̎bl */

	if (MW > 0) {		/* 󎚉\̍ő啝̎w肠Ƃ */
		if (w > MW) {	/* ̏ꍇ͏ɋÛ͂ */
			RM += w - MW;/* pLFE}[W𑝂₷ */
			w = MW;
		}
	} else {			/* 󎚉\̍ő啝̎w薳Ƃ */
	 	MW = w;			/* ̕܂ň󎚂łƉ肷 */
	}

	if (MH > 0) {		/* 󎚉\̍ő咷̎w肠Ƃ */
		if (h > MH) {
			BM += h - MH;/* pF}[W𑝂₷ */
			h = MH;
		}
	} else {			/* 󎚉\̍ő咷̎w薳Ƃ */
     	MH = h;			/* ̒܂ň󎚂łƉ肷 */
	}

	/* ̎_ŁA(w, h) ̗͂pł̈󎚉\̈̃TCYƂȂĂ */

	if (w <= 0 || h <= 0) {
		error(PROGRAM_STOP
#ifdef	JAPANESE
		, "\̈悪܂FTCY֌WIvVv`FbN"
#else
		, "No printable area! Please examine size options."
#endif
		);
	}

	/* dvi t@CǂݎeLXgETCYɐݒ肵l
	 *iset_dimension() Őݒj͖āAݒ肵ȂB */
	dim->text_width  = ROUND(SP_TO_IN(w + LS) * dim->dpi);
	dim->text_height = ROUND(SP_TO_IN(h) * dim->DPI);

/* XebvRFāAItZbǧvZ */

	if (dim->print_direction == HORIZONTAL) {
		if (HC) {
			/* ɃZ^Oꍇ (dvi->u : eLXg) */

			/* pɑ΂ăZ^Oo[W */
			dim->x_offset
				= ROUND( SP_TO_IN( (PW - dvi->u)/2 - LM + HS + LS) * dim->dpi);

			/* 󎚉\ɑ΂ăZ^Oo[W */
			/*dim->x_offset
				= ROUND( SP_TO_IN( (w - dvi->u)/2 + LM + HS + LS) * dim->dpi);*/
		} else {
			/* Z^OȂꍇB
			 * ̏ꍇ́Ap̌_̍WA}[W
			 *  x_offset Ƃ΂悢BŁAʒuɈ󎚂͂B
			 */
			dim->x_offset = ROUND((SP_TO_IN(OX - LM + LS) + 1) * dim->dpi);
		}

		if (VC) {
			/* ɃZ^Oꍇ (dvi->l : eLXg) */

			/* pɑ΂ăZ^Oo[W */
			dim->y_offset
				= ROUND( SP_TO_IN( (PH - dvi->l)/2 - TM + VS) * dim->DPI);

			/* 󎚉\ɑ΂ăZ^Oo[W */
			/*dim->y_offset
				= ROUND( SP_TO_IN( (h - dvi->l)/2 + TM + VS) * dim->DPI);*/
		} else {
			dim->y_offset = ROUND((SP_TO_IN(OY - TM) + 1) * dim->DPI);
		}
	} else {
		/* i.e. dim->print_direction == VERTICAL
		 *
		 * cɒupɁA90x]`ň͂B
		 *
		 * ̏ꍇ́ApEił͂ȂIjɁAdvit@Č_B
		 * ̌_ApE_ (1in,1in) ̈ʒuɁAi_ړ
		 * ȂAcuňpɒ߂ƂA_ɂ
		 * (1in + OX, 1in + OY) ̈ʒuɗ悤Ɂj [xy]_offset 𒲐Ȃ
         * ȂB
		 *
		 * ̎A[xy]_offset  dvit@C̍Wnł͂ȂApE
		 * ƂWnŎw肷Kv邱ƂɒӁBȂ킿Ax_offset ́A
		 * 󎚉\̈E[猴_܂ł̋łB܂Ay_offset ͈
		 * \̈[猴_܂ł̋łB
		 *
		 * Z^OȂꍇ́A
		 * x_offset ́Advit@C_YWE}[W
		 * y_offset ́Advit@C_XW}[W
		 * Ƃ΂悢B
		 */
		if (HC) {
			/* ɃZ^Oꍇ
			 * dvit@C̍gƂɒ  (dvi->l : eLXg) */

			/* pɑ΂ăZ^Oo[W */
			dim->x_offset
				= ROUND( SP_TO_IN( (PW - dvi->l)/2 - RM - HS) * dim->dpi);

			/* 󎚉\ɑ΂ăZ^Oo[W */
			/*dim->x_offset
				= ROUND( SP_TO_IN( (w - dvi->l)/2 + RM - HS) * dim->dpi);*/
		} else {
			dim->x_offset = ROUND((SP_TO_IN(OY - RM) + 1) * dim->dpi);
		}

		if (VC) {
			/* ɃZ^Oꍇ */

			/* pɑ΂ăZ^Oo[W */
			dim->y_offset
				= ROUND( SP_TO_IN( (PH - dvi->u)/2 - TM + VS) * dim->DPI);

			/* 󎚉\ɑ΂ăZ^Oo[W */
			/*dim->y_offset
				= ROUND( SP_TO_IN( (h - dvi->u)/2 + TM + VS) * dim->DPI);*/
		} else {
			dim->y_offset = ROUND((SP_TO_IN(OX - TM) + 1) * dim->DPI);
		}
	}

/* XebvSFő󎚉\̈̃hbg̐ݒ */

	/* dviprt only */
	dim->max_width  = ROUND(SP_TO_IN(MW) * dim->dpi);
	dim->max_height = ROUND(SP_TO_IN(MH) * dim->DPI);
}

static void pixel_init(DVIFILE_INFO *dvi, DIMENSION *dim)
	/* \g̐ݒD
     */
{
	long free_size, bb_size;
	int f_raster;
	PIXEL t_w, t_h;
#ifndef	NEMS
	int i, j, raster_page;
#endif

	ENTER("pixel_init");

	if (f_use_new_size_option) calc_new_size_option(dvi, dim);
	else{
		if (dim->print_direction == HORIZONTAL) {
			dim->text_width += dim->x_offset + add_width;
			dim->text_height += dim->y_offset + add_height;
			if (f_max_bb){
				if (dim->max_width  > 0) dim->text_width  = dim->max_width;
				if (dim->max_height > 0) dim->text_height = dim->max_height;
			}
		}
		else{
			dim->text_height += dim->x_offset + add_width;
			dim->text_width += dim->y_offset + add_height;
			if (f_max_bb){
				if (dim->max_height > 0) dim->text_width  = dim->max_height;
				if (dim->max_width > 0) dim->text_height = dim->max_width;
			}
			t_w = dim->text_height;
			t_h = dim->text_width;
			goto bb;
		}
	}
	t_w = dim->text_width;
	t_h = dim->text_height;
bb:	bb_size = ((long)(t_w + (HORI_DIVIDE - 1))) / HORI_DIVIDE
			* (HORI_DIVIDE / 8) *
			(((long)(t_h + (vert_divide - 1))) / vert_divide * vert_divide);
#ifndef	NEMS
 #ifdef FDOWN
	if (!f_download)
		system_ems[1] = f_jdwn = 0;
 #endif
	for (i = j = 0; system_ems[i] != -1; i++){
		if (j + system_ems[i] <= total_EMS_page) j += system_ems[i];
		else system_ems[i] = 0;
	}
 #ifdef	JDWN
	if (f_jdwn & system_ems[1] == 0)
		 dj = farmalloc(0x4000L);
	else dj = (DJTABLE*)pf_addr;
 #endif
	raster_page = ((total_EMS_page - j)/4)*4;
	if( raster_page > 0 ){
		buffers[0].type |= f_EMS;
		buffers[0].ems_last = raster_page;
	}
	else raster_page = 0;
#else
 #ifdef	JDWN
	if (f_download){
		if (f_jdwn)
			dj = farmalloc(0x4000L);
	}
	else f_jdwn = 0;
 #endif
#endif
	if (buffers[0].size < 0) {
		f_raster = -1;
		buffers[0].size = -buffers[0].size;
	}
	else f_raster = (buffers[0].size == 0L)? 0:0x4000;

#ifndef	NOVFONT
	if (vfont_name != NULL && *vfont_name != '-' && buffers[3].size == -1)
		buffers[3].size = 0x5001;
#endif

	free_size = (long)leftbuffer() - buffers[0].size - buffers[1].size
		- buffers[2].size - buffers[3].size - (FAR_HEAP + 0x100);

	if (buffers[2].size == 0L) {
		free_size -= (buffers[2].size = 80000L);
		if (free_size > 0) {
			if (f_raster
#ifndef NEMS
				- raster_page
#endif
				 >= 0)
				buffers[0].size += (free_size >>= 1);
			buffers[2].size += free_size;
			if ((free_size = (buffers[2].size - bb_size)) <= 0) goto fr_0;
			buffers[2].size = bb_size;
		}else
fr_0:		free_size = 0;
	}
	if (buffers[0].size <= 0x2000
#ifndef NEMS
	  && !raster_page
#endif
	){
		buffers[0].size = 0x2000;
		buffers[2].size -= 0x2000;
	}
	if (bb_size > 0x2000 && buffers[2].size <= 0x2000){
		buffers[2].size = 0x2000;
		buffers[0].size -= 0x2000;
	}
	if (buffers[3].size < 0)
		buffers[3].size = (free_size >= 2048)? free_size:0;
	if (buffers[3].size == 0x5001)
		buffers[3].size += free_size;
	if (dim->print_direction == HORIZONTAL)
		dim->split = set_size(t_w, t_h, dim->max_width, dim->max_height,
						&dim->buf_width, &dim->buf_height);
	else{
		dim->split = set_size(t_w, t_h, dim->max_width, dim->max_height,
						&dim->buf_height, &dim->buf_width);
		dim->y_offset += dim->buf_height - t_w;
	}
	END();
}

static void make_page_index(DVIFILE_INFO *dvi, DIMENSION *dim)
{
	int i;
	long offset;

	ENTER("make_page_index");

	dim->page_index =
		(PAGE_INDEX *)marea(sizeof(PAGE_INDEX) * (dvi->total_page + 1));

	for (offset = dvi->last_bop, i = dvi->total_page; i > 0; i--) {
		fseek(dvi->file_ptr, offset, SEEK_SET);
		if ((uchar)read_byte(dvi->file_ptr) != BOP)
			error(COMMAND_ERROR, "No BOP command in page %d", i);

		dim->page_index[i].offset = offset;
		dim->page_index[i].number = read_long(dvi->file_ptr);
		/* Read count[0] */
		fseek(dvi->file_ptr, 36L, SEEK_CUR);
		/* Skip other 'count' values */
		offset = read_long(dvi->file_ptr);
	}

	END();
}

/* end of file : prtinit.c */
