/*
*               TeX Device Driver DVIOUT, DVIPRT 
*               MS Windows  TrueType font g
*
*                            ttfont.c
*
*     "{vÓAT.Minagawa  vfont.c, vdata.c, vraster.c,
*      Naochan!  jgfont.c QlɂĂC܂̃vO
*      ɑSʓIɈˑĂ܂B
*      TrueType font ̏ڍׂɂẮA"TrueType font specifications",
*      "tffname.c" ( (c) Microsoft Corporation.) Qlɂ
*      ܂B
*
*      14 Nov. 1993  by I.Matsuda
*      29 May  1994  Supported CM-TT font  by I.Matsuda
*       2 June 1994  Bug fixed for ascgrp.ttf  by I.Matsuda
*       9 June 1994  Supported new CM-TT font  by I.Matsuda
*      17 Nov. 1994  Bug fixed by I.Matsuda
*/

#include <stdio.h>
#include <stdlib.h>
#include <dir.h>
#include <string.h>
#include <io.h>
#include <dos.h>
#include <fcntl.h>
#include <alloc.h>
#include "dd.h"
#include "err.h"
#include "buffer.h"
#include "vfont.h"
#include "vraster.h"
#include "ttfont.h"

static TT_INFO *TTinfo[MAX_VFONT];
static CMTT_INFO far *cmtt_ptr;
static GLYPH glyph;
static int basis[3][15];				/* XvC̊ */
static BOOL f_more_glyph = FALSE;		/* composite glyph */

/* vfont.c */
extern V_FONT *vfont[MAX_VFONT];

int get_ttinfo(int, int);
uchar *get_cmttinfo(int);
ulong get_glyph_offset(int, uint);
void ttf_metrics(FONT_INFO *, int, PREAMBLE *);
int seek_to_tt_data(VPARA_TBL *);
int get_tt_glyph(VPARA_TBL *);
long load_composite_glyph(VPARA_TBL *);
int get_tt_list(int);
int get_tt_xy(LOCATE *);
double read_F2Dot14(int);
long tt_seek(int , long , int);
ulong read_n_byte(int , int);

/* vfont.c */
int open_vfont(int, char *, char *, char *, char *);

/* vdata.c */
extern short bufx[VF_BUF_SIZE];	/* f[^ǂ݃obt@ */

/* buffer.c */
char *marea(unsigned int);

/* getfont.c */
long tfm_width(BUFFER *, int);

/* loadpk.c */
int openf(char *, int);

/* sptopxl.asm  */
PIXEL sptopixel(SCALED_PT);
PIXEL vtopixel(SCALED_PT);

/* mult20.asm */
SCALED_PT mult20(SCALED_PT, SCALED_PT);


/*************************************************************
*	get_ttinfo
*	*.tti ̃wb_擾
**************************************************************/
int get_ttinfo(int font_no, int fh)
{
	TTinfo[font_no] = (TT_INFO *)marea(sizeof(TT_INFO));
	tt_seek(fh, 0, SEEK_SET);
	TTinfo[font_no]->CodeTable	 = read_n_byte(fh, 2);
	TTinfo[font_no]->MaxJIS		 = read_n_byte(fh, 2);
	TTinfo[font_no]->unitsPerEm	 = read_n_byte(fh, 2);
	TTinfo[font_no]->xMin		 = (int)read_n_byte(fh, 2);
	TTinfo[font_no]->yMin		 = (int)read_n_byte(fh, 2);
	TTinfo[font_no]->maxPoints	 = read_n_byte(fh, 2);
	TTinfo[font_no]->maxContours = read_n_byte(fh, 2);
	TTinfo[font_no]->IndexBase	 = read_n_byte(fh, 4);
	TTinfo[font_no]->GlyphBase	 = read_n_byte(fh, 4);
	return (TRUE);
}

/*************************************************************
*	get_cmttinfo
*	 TT font ̃wb_擾
**************************************************************/
uchar *get_cmttinfo(int fh)
{
	int i, j, item = 0;
	BUFFER *p;
	uint numOffsets, numTables;
	ulong tag, offset, offset2;
	static CMTT_INFO cmtt_info;

	tt_seek(fh, 4, SEEK_SET);
	if ((numOffsets = read_n_byte(fh, 2)) > 100)
		return (NULL);
	lseek(fh, 12, SEEK_SET);
	read(fh, tmp_buf, numOffsets << 4);
	p = (BUFFER *)tmp_buf;
	for (i = 0; i < numOffsets; i++) {
		tag = get_long(p);
		move_ptr(p, 4);
		offset = get_long(p);
		move_ptr(p, 4);
		switch (tag)
		{
			case (tag_FontHeader):
				tt_seek(fh, offset + 18, SEEK_SET);
				cmtt_info.unitsPerEm = read_n_byte(fh, 2);
				tt_seek(fh, 30, SEEK_CUR);
				cmtt_info.indexToLocFormat = read_n_byte(fh, 2);
				item |= 0x01;
				break;
			case (tag_HoriHeader):
				tt_seek(fh, offset + 34, SEEK_SET);
				cmtt_info.numOfHMetrics = read_n_byte(fh, 2);
				item |= 0x02;
				break;
			case (tag_HorizontalMetrics):
				cmtt_info.HmtxBase = offset;
				item |= 0x04;
				break;
			case (tag_IndexToLoc):
				cmtt_info.IndexBase = offset;
				item |= 0x08;
				break;
			case (tag_GlyphData):
				cmtt_info.GlyphBase = offset;
				item |= 0x10;
				break;
			case (tag_CharToIndexMap):
				tt_seek(fh, offset + 2, SEEK_SET);
				numTables = read_n_byte(fh, 2);
				for (j = 0; j < numTables; j++) {
					tt_seek(fh, offset + 8 + (j << 3), SEEK_SET);
					offset2 = read_n_byte(fh, 4);
					tt_seek(fh, offset + offset2, SEEK_SET);
					cmtt_info.C2IndexFormat = (uint)read_n_byte(fh, 2);
					if (cmtt_info.C2IndexFormat == 0) {
						cmtt_info.CmapBase = offset + offset2 + 6;
						item |= 0x20;
						break;
					}
					if (cmtt_info.C2IndexFormat == 6) {
						tt_seek(fh, 4, SEEK_CUR);
						cmtt_info.FirstCode = (uint)read_n_byte(fh, 2);
						cmtt_info.EntryCount = (uint)read_n_byte(fh, 2);
						cmtt_info.CmapBase = offset + offset2 + 10;
						item |= 0x20;
						break;
					}
				}
				break;
			default:
				break;
		}
	}
	if (item != 0x3f) return (NULL);
	return ((uchar *)&cmtt_info);
}

/*************************************************************
*	get_glyph_offset
*	glyph f[^̐擪AhX擾
**************************************************************/
ulong get_glyph_offset(int fh, uint index)
{
	ulong offset;

	/* glyph f[^̈ʒu߂ */
	if (glyph.indexToLocFormat == 0) {		/* short format */
		tt_seek(fh, glyph.IndexBase + ((long)index << 1), SEEK_SET);
		offset = (ulong)read_n_byte(fh, 2) << 1;
	} else {								/* long format */
		tt_seek(fh, glyph.IndexBase + ((long)index << 2), SEEK_SET);
		offset = (ulong)read_n_byte(fh, 4);
	}
	/* glyph f[^̈ʒu seek āC֊sC_̐𒲂ׂ */
	tt_seek(fh, glyph.GlyphBase + offset, SEEK_SET);
	glyph.num_cts  = (int)read_n_byte(fh, 2);
	tt_seek(fh, 8 + ((glyph.num_cts - 1) << 1), SEEK_CUR);
	glyph.num_pts  = (uint)read_n_byte(fh, 2) + 1;
	tt_seek(fh, glyph.GlyphBase + offset, SEEK_SET);
	return(offset);
}


/*************************************************************
*	ttf_metrics
*	 TT font  metrics 𓾂
**************************************************************/
void ttf_metrics(FONT_INFO *font, int char_code, PREAMBLE *preamble)
{
	int i, fh, org_code;
	long lsb, adv;
	ulong offset;
	uint index;
	double dotsize, tmp;

	if (font->ext.fh <= 0)
		font->ext.fh = openf(font->name, O_RDONLY | O_BINARY);
	fh = font->ext.fh;
	cmtt_ptr = (CMTT_INFO far *)(font->pk + 4);

	/* glyph index ߂ */
	org_code = char_code;
	if ((char_code & 0x7f) <= 0x20) char_code ^= 0x80;
	else if (char_code == 0x7f) char_code = 0xa1;
	else if (char_code == 0xa1) char_code = 0x7f;
	if (cmtt_ptr->C2IndexFormat == 0) {		/* format 0 */
		tt_seek(fh, cmtt_ptr->CmapBase + char_code, SEEK_SET);
		index = (uchar)read_n_byte(fh, 1);
	} else {								/* format 6 */
		char_code -= cmtt_ptr->FirstCode;
		if (char_code < 0 || char_code >= cmtt_ptr->EntryCount) {
			index = 0;
		} else {
			tt_seek(fh, cmtt_ptr->CmapBase + (char_code << 1), SEEK_SET);
			index = (uint)read_n_byte(fh, 2);
		}
	}

	/* hmtx table  advance width, left side bearing ǂ */
	offset = (index < cmtt_ptr->numOfHMetrics)?
		(index << 2) : ((cmtt_ptr->numOfHMetrics - 1) << 2);
	tt_seek(fh, cmtt_ptr->HmtxBase + offset, SEEK_SET);
	adv = (uint)read_n_byte(fh, 2);
	if (index >= cmtt_ptr->numOfHMetrics) {
		offset = (cmtt_ptr->numOfHMetrics + offset) << 1;
		tt_seek(fh, cmtt_ptr->HmtxBase + offset, SEEK_SET);
	}
	lsb = (int)read_n_byte(fh, 2);
	glyph.IndexBase = cmtt_ptr->IndexBase;
	glyph.GlyphBase = cmtt_ptr->GlyphBase;
	glyph.indexToLocFormat = cmtt_ptr->indexToLocFormat;
	glyph.unitsPerEm = cmtt_ptr->unitsPerEm;

	offset = get_glyph_offset(fh, index);
	/* glyph ̃oE_ metrics Zo */
	tt_seek(fh, 2, SEEK_CUR);
	cmtt_ptr->xMin = (int)read_n_byte(fh, 2);
	cmtt_ptr->yMin = (int)read_n_byte(fh, 2);
	cmtt_ptr->xMax = (int)read_n_byte(fh, 2);
	cmtt_ptr->yMax = (int)read_n_byte(fh, 2);

#define CEIL(X)  (((X) > (int)(X)) ? ((int)(X) + 1) : ((int)(X)))
#define FLOOR(X) (((X) < (int)(X)) ? ((int)(X) - 1) : ((int)(X)))

	/* dotsize = TT font ̍Wnɂ 1 dot ̑傫 */
	dotsize = (double)cmtt_ptr->unitsPerEm
			/ (double)sptopixel(font->size_para);
	tmp = (double)cmtt_ptr->xMin / dotsize;
	cmtt_ptr->xMin = FLOOR(tmp) * dotsize;
	tmp = (double)cmtt_ptr->xMax / dotsize;
	cmtt_ptr->xMax = CEIL(tmp) * dotsize;
	tmp = -(double)lsb / dotsize;
	preamble->pitch_offset = CEIL(tmp);
	preamble->width = (double)(cmtt_ptr->xMax-cmtt_ptr->xMin) / dotsize + 0.5;

	dotsize = (double)cmtt_ptr->unitsPerEm
			/ (double)vtopixel(font->size_para);
	tmp = (double)cmtt_ptr->yMin / dotsize;
	cmtt_ptr->yMin = FLOOR(tmp) * dotsize;
	tmp = (double)cmtt_ptr->yMax / dotsize;
	cmtt_ptr->yMax = CEIL(tmp) * dotsize;
	preamble->depth_offset = (double)cmtt_ptr->yMax / dotsize + 0.5;
	preamble->height = (double)(cmtt_ptr->yMax-cmtt_ptr->yMin) / dotsize + 0.5;

	if (cmtt_ptr->f_have_tfm == TRUE) {		/* tfm ΂𗘗p */
		preamble->tfm_width =
			mult20(tfm_width(font->pk + sizeof(CMTT_INFO) + 4, org_code),
			font->size_para);
	} else {
		preamble->tfm_width = ((((long)(adv) * (font->size_para >> 4))
							/ cmtt_ptr->unitsPerEm) << 4);
	}
	/* glyph f[^擪 seek  */
	tt_seek(fh, cmtt_ptr->GlyphBase + offset, SEEK_SET);
}


/*************************************************************
*	seek_to_tt_data
*	a TrueType font file  glyph f[^擪܂ŃV[N
**************************************************************/
int seek_to_tt_data(VPARA_TBL *tbl_ptr)
{
	int font_no, tti_fh, ttf_fh;
	uint gindex;
	ulong offset;

	font_no = tbl_ptr->font_no;
	if ((tti_fh = vfont[font_no]->v_fh[1]) <= 0) return (FAILURE);
	ttf_fh = tbl_ptr->vfn_file;

	if ((tbl_ptr->char_code >> 8) - 0x21 >= TTinfo[font_no]->MaxJIS) {
		return (FAILURE);
	}
	/* glyph index ߂ */
	
	offset = TTinfo[font_no]->CodeTable + tbl_ptr->v_code * 2L;
	tt_seek(tti_fh, offset, SEEK_SET);
	gindex = (uint)read_n_byte(tti_fh, 2);
	if (gindex == 0) return (FAILURE);		/* Y glyph  */

	/* glyph f[^擪 seek  */
	glyph.IndexBase = TTinfo[font_no]->IndexBase;
	glyph.GlyphBase = TTinfo[font_no]->GlyphBase;
	glyph.indexToLocFormat = 1;
	glyph.unitsPerEm = TTinfo[font_no]->unitsPerEm;
	offset = get_glyph_offset(ttf_fh, gindex);

	return (TRUE);
}

/*************************************************************
*	get_tt_glyph
*	glyph ̎擾
**************************************************************/
int get_tt_glyph(VPARA_TBL *tbl_ptr)
{
	uint i;
	int font_no, fh, poff;
	static long seekp_sav;

	font_no = tbl_ptr->font_no;
	fh = tbl_ptr->vfn_file;

	if (f_more_glyph != TRUE) {
		tt_seek(fh, 10, SEEK_CUR);
		if (glyph.num_cts == 0) return (FAILURE);
		if (glyph.num_cts == -1) goto composite;
		if (glyph.num_cts < -1) goto err;
		if (get_tt_list(fh) == FAILURE) goto err;
	} else {	/* composite glyph */
		tt_seek(fh, seekp_sav, SEEK_SET);

composite:
		seekp_sav = load_composite_glyph(tbl_ptr);
		if (seekp_sav == -1) goto err;
	}

	/* Wnϊ */
	poff = (tbl_ptr->font_type == CMTTF)?
		cmtt_ptr->xMin : TTinfo[font_no]->xMin;
	for (i = 0; i < glyph.num_pts; i++) {
		glyph.xlist[i] = ((long)(glyph.xlist[i] - poff) * MAX_RANGE)
						/ glyph.unitsPerEm;
	}
	poff = (tbl_ptr->font_type == CMTTF)?
		cmtt_ptr->yMax : (glyph.unitsPerEm + TTinfo[font_no]->yMin);
	for (i = 0; i < glyph.num_pts; i++) {
		glyph.ylist[i] = ((long)(poff - glyph.ylist[i]) * MAX_RANGE)
						/ glyph.unitsPerEm;
	}
	return (TRUE);

err:
	error(WARNING, "[TTfont] data error.(%#x) %s",
		tbl_ptr->char_code, tbl_ptr->v_font_name);
	return (FAILURE);
}

/*************************************************************
*	load_composite_glyph
*	composite glyph ̏
**************************************************************/
long load_composite_glyph(VPARA_TBL *tbl_ptr)
{
	double Trans[2][3];
	uint flags, index;
	int fh, i, x, y;
	ulong offset;

	fh = tbl_ptr->vfn_file;
	flags = (uint)read_n_byte(fh, 2);
	index = (uint)read_n_byte(fh, 2);
	if (flags & ARG_1_AND_2_ARE_WORDS) {
		Trans[0][2] = (int)read_n_byte(fh, 2);
		Trans[1][2] = (int)read_n_byte(fh, 2);
	} else {
		i = (int)read_n_byte(fh, 2);
		Trans[1][2] = (char)(i & 0xff);
		Trans[0][2] = (char)(i >> 8);
	}
	Trans[0][1] = Trans[1][0] = 0.0;
	Trans[0][0] = Trans[1][1] = 1.0;
	if (flags & WE_HAVE_A_SCALE) {
		Trans[0][0] = Trans[1][1] = read_F2Dot14(fh);
	} else if (flags & WE_HAVE_AN_X_AND_Y_SCALE) {
		Trans[0][0] = read_F2Dot14(fh);
		Trans[1][1] = read_F2Dot14(fh);
	} else if (flags & WE_HAVE_A_TWO_BY_TWO) {
		Trans[0][0] = read_F2Dot14(fh);
		Trans[1][0] = read_F2Dot14(fh);
		Trans[0][1] = read_F2Dot14(fh);
		Trans[1][1] = read_F2Dot14(fh);
	}
	offset = read_n_byte(fh, 0);
	get_glyph_offset(fh, index);
	tt_seek(fh, 10, SEEK_CUR);
	if (get_tt_list(fh) == FAILURE) return (-1);
/*	printf("%10.4f%10.4f%10.4f\n", Trans[0][0], Trans[0][1], Trans[0][2]);
	printf("%10.4f%10.4f%10.4f\n", Trans[1][0], Trans[1][1], Trans[1][2]);*/
	/* ό` */
	for (i = 0; i < glyph.num_pts; i++) {
		x = glyph.xlist[i];
		y = glyph.ylist[i];
		glyph.xlist[i] = x * Trans[0][0] + y * Trans[0][1] + Trans[0][2];
		glyph.ylist[i] = x * Trans[1][0] + y * Trans[1][1] + Trans[1][2];
	}
	f_more_glyph = (flags & MORE_COMPONENTS)? TRUE : FALSE;
	return (offset);
}

/*************************************************************
*	get_tt_list
*	xlist, ylist ̎擾
**************************************************************/
int get_tt_list(int fh)
{
	uint i, j;
	int cp, buffsize;

	/* [Nobt@̊m */
	buffsize = sizeof(int) * (glyph.num_cts + glyph.num_pts + glyph.num_pts)
			 + sizeof(char) * glyph.num_pts;
	if ((glyph.end_pts = (uint *)marea(buffsize)) == NULL)
		return(FAILURE);
	glyph.flist = (uchar *)(&glyph.end_pts[glyph.num_cts]);
	glyph.xlist = (int *)(&glyph.flist[glyph.num_pts]);
	glyph.ylist = (int *)(&glyph.xlist[glyph.num_pts]);

	/* e֊s̏I_Xg */
	for (i = 0; i < glyph.num_cts; i++) {
		glyph.end_pts[i] = (uint)read_n_byte(fh, 2);
	}

	/* instruction (hint ) ͖ */
	i = read_n_byte(fh, 2);		/* instruction ̒ */
	tt_seek(fh, i, SEEK_CUR);

	/* flag  */
	for (i = 0; i < glyph.num_pts; i++) {
		glyph.flist[i] = (uchar)read_n_byte(fh, 1);
		if (glyph.flist[i] & REPEAT_FLAGS) {
			for (j = (uchar)read_n_byte(fh, 1);
				j > 0; j--, i++) {
				glyph.flist[i + 1] = glyph.flist[i];
			}
		}
	}
	/* x W */
	cp = 0;
	for (i = 0; i < glyph.num_pts; i++) {
		if (glyph.flist[i] & XSHORT) {
			if (glyph.flist[i] & SHORT_X_IS_POS) {
				cp += (uchar)read_n_byte(fh, 1);
			} else {
				cp -= (uchar)read_n_byte(fh, 1);
			}
		} else {
			if (!(glyph.flist[i] & NEXT_X_IS_ZERO)) {
				cp += (int)read_n_byte(fh, 2);
			}
		}
		glyph.xlist[i] = cp;
	}
	/* y W */
	cp = 0;
	for (i = 0; i < glyph.num_pts; i++) {
		if (glyph.flist[i] & YSHORT) {
			if (glyph.flist[i] & SHORT_Y_IS_POS) {
				cp += (uchar)read_n_byte(fh, 1);
			} else {
				cp -= (uchar)read_n_byte(fh, 1);
			}
		} else {
			if (!(glyph.flist[i] & NEXT_Y_IS_ZERO)) {
				cp += (int)read_n_byte(fh, 2);
			}
		}
		glyph.ylist[i] = cp;
	}
	glyph.cp = -1;
	glyph.cc = 0;
	return (TRUE);

}

/*************************************************************
*	get_tt_xy
*	Wf[^̎擾
**************************************************************/
int get_tt_xy(LOCATE *locate)
{
	static int sp, ep;				/* ֊s̎n_AI_̃|C^ */
	static int p1, p2, p3;			/* XvC\鐧_̃|C^ */
	static int t = -1, step;		/* XvCȐ̎ (t=0,1,...,15) */
	static LOCATE k1, k2, k3;
	int x, y;
	int len;

	if (t < 0) {					/* XvC̊ (256 {) */
		for (t = 1; t < 16; t++) {
			basis[0][t - 1] = (16 - t) * (16 - t);
			basis[1][t - 1] = 128 - (t - 8) * (t - 8) * 2;
			basis[2][t - 1] = t * t;
		}
	}
	if (glyph.cp < 0) {				/* ݒ */
		t = sp = 0;
		ep = glyph.end_pts[0];
		glyph.cp = 0;
	}

	if (t > 0) {				/* XvC̓r */
		x = ((long)basis[0][t - 1] * k1.x
		   + (long)basis[1][t - 1] * k2.x
		   + (long)basis[2][t - 1] * k3.x + 128L) >> 8;
		y = ((long)basis[0][t - 1] * k1.y
		   + (long)basis[1][t - 1] * k2.y
		   + (long)basis[2][t - 1] * k3.y + 128L) >> 8;
		t += step;
		if (t >= 16) {
			t = 0;
			glyph.cp++;
		}
	} else {
retry:
		if (glyph.cp > ep) {
			if (glyph.cp >= glyph.num_pts) {
				if (glyph.end_pts != NULL) {
					free((void *)glyph.end_pts);
					glyph.end_pts = NULL;
				}
				if (f_more_glyph == TRUE)
					return (FALSE);		/* composite glyph */
				return (NOMORE);		/* Sf[^̍Ō */
			}
			sp = ep + 1;
			ep = glyph.end_pts[++glyph.cc];
			t = 0;
			return (NOMORE);			/* ֊s̍Ō */
		}
		p1 = glyph.cp;
		p2 = (p1 < ep)? (p1 + 1) : sp;
		p3 = (p2 < ep)? (p2 + 1) : sp;
		if (glyph.flist[p1] & glyph.flist[p2] & ONCURVE) {	/*  */
			x = glyph.xlist[p1];
			y = glyph.ylist[p1];
			glyph.cp++;
		} else if (glyph.flist[p2] & ONCURVE) {
			glyph.cp++;
			goto retry;
		} else {								/* 2  B XvC */
			if (glyph.flist[p1] & ONCURVE) {
				k1.x = glyph.xlist[p1];
				k1.y = glyph.ylist[p1];
			} else {
				k1.x = (glyph.xlist[p1] + glyph.xlist[p2] + 1) / 2;
				k1.y = (glyph.ylist[p1] + glyph.ylist[p2] + 1) / 2;
			}
			k2.x = glyph.xlist[p2];
			k2.y = glyph.ylist[p2];
			if (glyph.flist[p3] & ONCURVE) {
				k3.x = glyph.xlist[p3];
				k3.y = glyph.ylist[p3];
			} else {
				k3.x = (glyph.xlist[p2] + glyph.xlist[p3] + 1) / 2L;
				k3.y = (glyph.ylist[p2] + glyph.ylist[p3] + 1) / 2L;
			}
			/* step قǐx͍Ȃ */
			len = abs(k3.x - k2.x) + abs(k3.y - k2.y)
				+ abs(k2.x - k1.x) + abs(k2.y - k1.y);
			if (len > 500) {
				step = 1;
			} else if (len > 100) {
				step = 2;
			} else {
				step = 4;
			}
			x = k1.x;
			y = k1.y;
			t += step;
		}
	}
	locate->x = x;
	locate->y = y;
	return (TRUE);
}

/*************************************************************
*	read_F2Dot14
*	Fixed point format ǂݍ
**************************************************************/
double read_F2Dot14(int fh)
{
	int Mantissa, Fraction;

	Fraction = read_n_byte(fh, 2);
	Mantissa = Fraction >> 14;
	Fraction &= 0x3fff;
	return ((double)Mantissa + (double)Fraction / 16384.0);
}

static uchar *buf = (uchar *)bufx;
static int bp;
static long seekp;

/*************************************************************
*	tt_seek
*	fromwhere = SEEK_SET : Ύw
*	else : |C^i߂ (offset << VF_BUF_SIZE)
*************************************************************/
long tt_seek(int fh, long offset, int fromwhere)
{
	if (fromwhere == SEEK_SET) {
		seekp = offset;
		lseek(fh, offset, SEEK_SET);
		read(fh, buf, VF_BUF_SIZE);
		bp = 0;
	} else {
		bp += offset;
		while (bp >= VF_BUF_SIZE) {
			read(fh, buf, VF_BUF_SIZE);
			seekp += VF_BUF_SIZE;
			bp -= VF_BUF_SIZE;
		}
	}
	return (seekp + bp);
}

/*************************************************************
*	ᐅo͊֐ n byte ǂݍ
*	n = 0 : ݂̃|C^Ԃ (tell)
*	n > 0 : n byte (n <= 4) ǂݍ
**************************************************************/
ulong read_n_byte(int fh, int n)
{
	ulong mask = 0;
	union {
		long num;
		char c[4];
	} d;

	if (n <= 0) n = 0;
	if (n > 4) n = 4;

	if (n == 0) return (seekp + bp);

	while (--n >= 0) {
		d.c[n] = buf[bp];
		mask = (mask << 8) | 0xffL;
		if (++bp >= VF_BUF_SIZE) {
			read(fh, buf, VF_BUF_SIZE);
			bp = 0;
		}
	}
	return (d.num & mask);
}

